// MeshTab.cpp : implementation file
//

#include "stdafx.h"
#include "SensorSim.h"
#include "MeshTab.h"
#include "SensorSimDlg.h"
#include "ga/GASStateGA.h"
#include "ga/GA1DArrayGenome.h"
#include "CommonFnc.h"
#include "sha1.h"
#include "md5.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSensorSimDlg*  pSensorSim;


//GA_CIRCUIT  gaCirc;
/////////////////////////////////////////////////////////////////////////////
// CMeshTab dialog


CMeshTab::CMeshTab(CWnd* pParent /*=NULL*/)
	: CDialog(CMeshTab::IDD, pParent)
    , m_numLayers(_T("8"))
    , m_numTestInputs(_T("100"))
    , m_numFncInLayer(_T("16"))
    , m_numFncOutLayer(_T("16"))
    , m_algRounds(_T("1"))
    , m_limitAlgRounds(FALSE)
    , m_fncNOP(TRUE)
    , m_fncOR(TRUE)
    , m_fncAND(TRUE)
    , m_fncXOR(TRUE)
    , m_fncNOR(TRUE)
    , m_fncNAND(TRUE)
    , m_fncROTL(TRUE)
    , m_fncROTR(TRUE)
    , m_fncSUM(TRUE)
    , m_fncSUBS(TRUE)
    , m_fncADD(TRUE)
    , m_fncMULT(TRUE)
    , m_fncDIV(TRUE)
    , m_fncCONST(TRUE)
    , m_fncBSEL(TRUE)
    , m_textInput(_T(""))
    , m_predictionType(0)
    , m_elemParticle(0)
    , m_testVectorGenerMethod(5)
    , m_testVectorChangeGener(_T("1"))
    , m_circuitInput(_T("01 02 03 04 05 06 07 08 01 02 03 04 05 06 07 08"))
    , m_sectorInputData(FALSE)
    , m_splitTestVectors(FALSE)
    , m_numBestPredictors(_T("5"))
    , m_limitLayerConnectors(FALSE)
    , m_layerConnectors(_T(""))
	, m_representBitsAsBytes(FALSE)
    , m_numSelectorLayers(_T(""))
{
	//{{AFX_DATA_INIT(CMeshTab)
	m_pathLen = _T("5");
	//}}AFX_DATA_INIT
}

CMeshTab::~CMeshTab() {
}

void CMeshTab::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CMeshTab)
    //DDX_Text(pDX, IDC_PATH_LEN, m_pathLen);
    //}}AFX_DATA_MAP
    DDX_Text(pDX, IDC_GAC_NUMLAYERS, m_numLayers);
    DDX_Text(pDX, IDC_GAC_TESTSAMPLES, m_numTestInputs);
    DDX_Text(pDX, IDC_NUM_FNC_LAYER, m_numFncInLayer);
    DDX_Text(pDX, IDC_NUM_OUTPUTS, m_numFncOutLayer);
    DDX_Text(pDX, IDC_MD5_ROUNDS, m_algRounds);
    DDX_Check(pDX, IDC_LIMIT_MD5_ROUNDS, m_limitAlgRounds);
    DDX_Text(pDX, IDC_CIRCUIT, m_textInput);

    DDX_Check(pDX, IDC_NOP , m_fncNOP);
    DDX_Check(pDX, IDC_OR  , m_fncOR);
    DDX_Check(pDX, IDC_AND , m_fncAND);
    DDX_Check(pDX, IDC_XOR , m_fncXOR);
    DDX_Check(pDX, IDC_NOR , m_fncNOR);
    DDX_Check(pDX, IDC_NAND, m_fncNAND);
    DDX_Check(pDX, IDC_ROTL, m_fncROTL);
    DDX_Check(pDX, IDC_ROTR, m_fncROTR);
    DDX_Check(pDX, IDC_SUM , m_fncSUM);
    DDX_Check(pDX, IDC_SUBS, m_fncSUBS);
    DDX_Check(pDX, IDC_ADD , m_fncADD);
    DDX_Check(pDX, IDC_MULT, m_fncMULT);
    DDX_Check(pDX, IDC_DIV , m_fncDIV);
    DDX_Check(pDX, IDC_CONST , m_fncCONST);
    DDX_Check(pDX, IDC_BITSELECTOR, m_fncBSEL);

    DDX_Radio(pDX, IDC_PREDICTION_METHOD, m_predictionType);
    DDX_Radio(pDX, IDC_ELEM_PARTICLE, m_elemParticle);
    DDX_Radio(pDX, IDC_TESTVECT_GENER_METHOD, m_testVectorGenerMethod);
    DDX_Text(pDX, IDC_TEST_VECTOR_CHANGE, m_testVectorChangeGener);
    DDX_Text(pDX, IDC_CIRCUIT_INPUT, m_circuitInput);
    DDX_Check(pDX, IDC_SECTOR_INPUT_DATA, m_sectorInputData);
    DDX_Check(pDX, IDC_SPLIT_TEST_VECT, m_splitTestVectors);
    DDX_Text(pDX, IDC_NUM_BEST_PREDICTORS, m_numBestPredictors);
    DDX_Text(pDX, IDC_LAYER_CONNECTORS, m_layerConnectors);
    DDX_Check(pDX, IDC_REPRESENT_BITS_AS_BYTES, m_representBitsAsBytes);
    DDX_Text(pDX, IDC_NUM_SELECTOR_LAYERS, m_numSelectorLayers);
}


BEGIN_MESSAGE_MAP(CMeshTab, CDialog)
	//{{AFX_MSG_MAP(CMeshTab)
	ON_BN_CLICKED(IDC_RAND_NEIGH_TOUR, OnRandNeighTour)
	//}}AFX_MSG_MAP
    ON_BN_CLICKED(IDC_START_GARNG, &CMeshTab::OnBnClickedStartGarng)
    ON_BN_CLICKED(IDC_CHECK1, &CMeshTab::OnBnClickedCheck1)
    ON_BN_CLICKED(IDC_EXECUTE_FROMTEXT, &CMeshTab::OnBnClickedExecuteFromtext)
    ON_BN_CLICKED(IDC_ALL_FNC, &CMeshTab::OnBnClickedAllFnc)
    ON_BN_CLICKED(IDC_NO_FNC, &CMeshTab::OnBnClickedNoFnc)
    ON_BN_CLICKED(IDC_RADIO1, &CMeshTab::OnBnClickedRadio1)
    ON_BN_CLICKED(IDC_SOFT_INTERRUPT, &CMeshTab::OnBnClickedSoftInterrupt)
    ON_BN_CLICKED(IDC_EXECUTE_FOR_INPUT, &CMeshTab::OnBnClickedExecuteForInput)
    ON_BN_CLICKED(IDC_DISTINGUISHER, &CMeshTab::OnBnClickedDistinguisher)
	ON_BN_CLICKED(IDC_EAC_TEST, &CMeshTab::OnBnClickedEacTest)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMeshTab message handlers

int CMeshTab::GetDlgData(BASIC_INIT_DATA* pBasicSettings) {
    int     status = STAT_OK;

    UpdateData(TRUE);
    pBasicSettings->gaCircuitConfig.numLayers = atoi(m_numLayers);
    pBasicSettings->gaCircuitConfig.numSelectorLayers = atoi(m_numSelectorLayers);
    pBasicSettings->gaCircuitConfig.numTestVectors = atoi(m_numTestInputs);
    pBasicSettings->gaCircuitConfig.internalLayerSize = atoi(m_numFncInLayer);
    pBasicSettings->gaCircuitConfig.numLayerConnectors = atoi(m_layerConnectors);
    if (pBasicSettings->gaCircuitConfig.internalLayerSize > MAX_INTERNAL_LAYER_SIZE) {
        LOG_INSERTSTRING("ERROR: Number of functions in internal layer too high"); 
        status = STAT_USERDATA_BAD;
    }
    pBasicSettings->gaCircuitConfig.outputLayerSize = atoi(m_numFncOutLayer);
    if (pBasicSettings->gaCircuitConfig.outputLayerSize > MAX_OUTPUTS) {
        LOG_INSERTSTRING("ERROR: Number of functions in output layer too high"); 
        status = STAT_USERDATA_BAD;
    }

    pBasicSettings->gaCircuitConfig.bSectorInputData = m_sectorInputData;
	pBasicSettings->gaCircuitConfig.limitAlgRounds = m_limitAlgRounds;
	pBasicSettings->gaCircuitConfig.limitAlgRoundsCount = atoi(m_algRounds);
	pBasicSettings->gaCircuitConfig.representBitAsBytes = m_representBitsAsBytes;

    pBasicSettings->gaCircuitConfig.predictMethod = m_predictionType;
    pBasicSettings->gaCircuitConfig.testVectorGenerMethod = m_testVectorGenerMethod;
    pBasicSettings->gaCircuitConfig.testVectorChangeGener = atoi(m_testVectorChangeGener);
    pBasicSettings->gaCircuitConfig.bSplitTestVectors = m_splitTestVectors;
    pBasicSettings->gaCircuitConfig.numBestPredictors = atoi(m_numBestPredictors);
    
    // ACTUAL SIZE OF GENOM
//    pBasicSettings->gaCircuitConfig.genomeSize = (pBasicSettings->gaCircuitConfig.numLayers * 2) * MAX_INTERNAL_LAYER_SIZE;
    pBasicSettings->gaCircuitConfig.genomeSize = MAX_GENOME_SIZE;

    // ALLOWED NODE FUNCTIONS 
    memset(pBasicSettings->gaCircuitConfig.allowedFNC, 0, sizeof(pBasicSettings->gaCircuitConfig.allowedFNC));   
	pBasicSettings->gaCircuitConfig.allowedFNC[FNC_NOP] = (m_fncNOR) ? 1 : 0;
	pBasicSettings->gaCircuitConfig.allowedFNC[FNC_OR] = (m_fncOR) ? 1 : 0;
	pBasicSettings->gaCircuitConfig.allowedFNC[FNC_AND] = (m_fncAND) ? 1 : 0;
	pBasicSettings->gaCircuitConfig.allowedFNC[FNC_CONST] = (m_fncCONST) ? 1 : 0;
	pBasicSettings->gaCircuitConfig.allowedFNC[FNC_XOR] = (m_fncXOR) ? 1 : 0;
	pBasicSettings->gaCircuitConfig.allowedFNC[FNC_NOR] = (m_fncNOR) ? 1 : 0;
	pBasicSettings->gaCircuitConfig.allowedFNC[FNC_NAND] = (m_fncNAND)? 1 : 0;
	pBasicSettings->gaCircuitConfig.allowedFNC[FNC_ROTL] = (m_fncROTL)? 1 : 0;
	pBasicSettings->gaCircuitConfig.allowedFNC[FNC_ROTR] = (m_fncROTR)? 1 : 0;
	pBasicSettings->gaCircuitConfig.allowedFNC[FNC_BITSELECTOR] = (m_fncBSEL)? 1 : 0;
	
	pBasicSettings->gaCircuitConfig.allowedFNC[FNC_SUM] = (m_fncSUM) ? 1 : 0;
	pBasicSettings->gaCircuitConfig.allowedFNC[FNC_SUBS] = (m_fncSUBS)? 1 : 0;
	pBasicSettings->gaCircuitConfig.allowedFNC[FNC_ADD] = (m_fncADD) ? 1 : 0;
	pBasicSettings->gaCircuitConfig.allowedFNC[FNC_MULT] = (m_fncMULT)? 1 : 0;
	pBasicSettings->gaCircuitConfig.allowedFNC[FNC_DIV] = (m_fncDIV) ? 1 : 0;

    // ALLOCATE STRUCTURE FOR TEST VECTORS
    pBasicSettings->gaCircuitConfig.allocate();        

    return status;
}

int CMeshTab::SetDlgData(BASIC_INIT_DATA* pBasicSettings) {
    int     status = STAT_OK;

    UpdateData(TRUE);
    m_numLayers.Format("%d", pBasicSettings->gaCircuitConfig.numLayers);
    m_numSelectorLayers.Format("%d", pBasicSettings->gaCircuitConfig.numSelectorLayers);
    m_numTestInputs.Format("%d", pBasicSettings->gaCircuitConfig.numTestVectors);
    m_numFncInLayer.Format("%d", pBasicSettings->gaCircuitConfig.internalLayerSize);
    m_layerConnectors.Format("%d", pBasicSettings->gaCircuitConfig.numLayerConnectors);
    if (pBasicSettings->gaCircuitConfig.internalLayerSize > MAX_INTERNAL_LAYER_SIZE) {
        LOG_INSERTSTRING("ERROR: Number of functions in internal layer too high"); 
        m_numFncInLayer.Format("%d", MAX_INTERNAL_LAYER_SIZE);
    }
    m_numFncOutLayer.Format("%d", pBasicSettings->gaCircuitConfig.outputLayerSize);
    if (pBasicSettings->gaCircuitConfig.outputLayerSize > MAX_OUTPUTS) {
        LOG_INSERTSTRING("ERROR: Number of functions in output layer too high"); 
        m_numFncOutLayer.Format("%d", MAX_OUTPUTS);
    }
    m_sectorInputData = pBasicSettings->gaCircuitConfig.bSectorInputData;
	m_limitAlgRounds = pBasicSettings->gaCircuitConfig.limitAlgRounds;
	m_algRounds.Format("%d", pBasicSettings->gaCircuitConfig.limitAlgRoundsCount);
	m_representBitsAsBytes = pBasicSettings->gaCircuitConfig.representBitAsBytes;

    m_predictionType = pBasicSettings->gaCircuitConfig.predictMethod;
    m_testVectorGenerMethod = pBasicSettings->gaCircuitConfig.testVectorGenerMethod;
    m_testVectorChangeGener.Format("%d", pBasicSettings->gaCircuitConfig.testVectorChangeGener);
    m_splitTestVectors = pBasicSettings->gaCircuitConfig.bSplitTestVectors;
    m_numBestPredictors.Format("%d", pBasicSettings->gaCircuitConfig.numBestPredictors);
    
    
    // ALLOWED NODE FUNCTIONS 
	m_fncNOP = (pBasicSettings->gaCircuitConfig.allowedFNC[FNC_NOP] == 1) ? TRUE : FALSE;
	m_fncOR = (pBasicSettings->gaCircuitConfig.allowedFNC[FNC_OR] == 1) ? TRUE : FALSE;
	m_fncAND = (pBasicSettings->gaCircuitConfig.allowedFNC[FNC_AND] == 1) ? TRUE : FALSE;
	m_fncCONST = (pBasicSettings->gaCircuitConfig.allowedFNC[FNC_CONST] == 1) ? TRUE : FALSE;
	m_fncXOR = (pBasicSettings->gaCircuitConfig.allowedFNC[FNC_XOR] == 1) ? TRUE : FALSE;
	m_fncNOR = (pBasicSettings->gaCircuitConfig.allowedFNC[FNC_NOR] == 1) ? TRUE : FALSE;
	m_fncNAND = (pBasicSettings->gaCircuitConfig.allowedFNC[FNC_NAND] == 1) ? TRUE : FALSE;
	m_fncROTL = (pBasicSettings->gaCircuitConfig.allowedFNC[FNC_ROTL] == 1) ? TRUE : FALSE;
	m_fncROTR = (pBasicSettings->gaCircuitConfig.allowedFNC[FNC_ROTR] == 1) ? TRUE : FALSE;
	m_fncSUM = (pBasicSettings->gaCircuitConfig.allowedFNC[FNC_SUM] == 1) ? TRUE : FALSE;
	m_fncSUBS = (pBasicSettings->gaCircuitConfig.allowedFNC[FNC_SUBS] == 1) ? TRUE : FALSE;
	m_fncADD = (pBasicSettings->gaCircuitConfig.allowedFNC[FNC_ADD] == 1) ? TRUE : FALSE;
	m_fncMULT = (pBasicSettings->gaCircuitConfig.allowedFNC[FNC_MULT] == 1) ? TRUE : FALSE;
	m_fncDIV = (pBasicSettings->gaCircuitConfig.allowedFNC[FNC_DIV]  == 1) ? TRUE : FALSE;

	UpdateData(FALSE);

    return status;
}


void CMeshTab::OnRandNeighTour() 
{
    //
    // PERFORM RANDOM N-HOP TOUR ACROSS NEIGBOURS AND CALCULATE FINAL DISTANCE
    //
    
    int                 remHops;
    DWORD               i;
    DWORD               neighNum;
    float               dist;
    float               avg = 0;
    DWORD               avgCount = 0;
    SENSOR_NODE*        pStartSensor;
    SENSOR_NODE*        pActualSensor;
    NEIGH_LIST_NODE*    pListNode;
    CString             value;
    CRndGen             rndGen;

    UpdateData(TRUE);

    if (pSensorSim->m_sensorEnv.m_pActualDeployment->sensorsDeployed) {
        for (i = 0; i < pSensorSim->m_sensorEnv.m_pActualDeployment->whiteSensorList.numSensors; i++) {
            pStartSensor = pSensorSim->m_sensorEnv.m_pActualDeployment->whiteSensorList.sensors[i];
            pListNode = pStartSensor->whiteNeigh;
        
            remHops = atoi(m_pathLen);
            pActualSensor = pStartSensor;

            // PERFORM N HOPS
            while (remHops > 0) {
                // FIND RANDOM NEIGHBOUR OF ACTUAL PIVOT NODE
                rndGen.GetRandomFromInterval(pActualSensor->numWhiteNeigh, &neighNum);
                pListNode = pActualSensor->whiteNeigh;
                while ((neighNum - 1) > 0) {
                    neighNum--;
                    pListNode = pListNode->next;
                }
                pActualSensor = (SENSOR_NODE*) pListNode->pItem;
                remHops--;
            }

            // CALCULATE DISTANCE OF END NODE FROM START ONE
            dist = (float) sqrt(pow(pStartSensor->cX - pActualSensor->cX, 2) + pow(pStartSensor->cY - pActualSensor->cY, 2));

            // AVERAGE PURPOSES
            avg += dist;
            avgCount++;
        }

        avg = avg / avgCount;

        value.Format("Average end node distance after %d-hops = %.2f", atoi(m_pathLen), avg); 
        LOG_INSERTSTRING(value);
    }
    else {
        LOG_INSERTSTRING("ERROR: Sensors not deployed yet.");
    }
}



void CMeshTab::OnBnClickedStartGarng()
{
    int     status = STAT_OK;

	UpdateData(TRUE);
    
    // OBTAIN BASIC GA SETTINGS
    BASIC_INIT_DATA basicSettings;
    pSensorSim->GetBasicSettings(&basicSettings);

	// SET TEST TYPE FOR THE CASE OF REMOTE EXECUTION
	basicSettings.testType |= FLAG_TESTTYPE_EVOLVECIRCUIT;
	
	// SAVE CONFIGURATION SCRIPT
	CString	cfgScriptPath;
	cfgScriptPath.Format("%s\\!cfgScript.ini", pSensorSim->m_basePath);
    status = pSensorSim->m_sensorEnv.SaveConfigScript(cfgScriptPath, &basicSettings);
    
    if (basicSettings.remoteConfig.actualRemoteHost == HOST_ACTUAL) {
		TEST_THREAD_PARAM*	pThreadParam = new TEST_THREAD_PARAM;
	    pSensorSim->GetBasicSettings(&(pThreadParam->basicSettings));

        // INTERRUPT PREVIOUS THREAD
        if (pSensorSim->m_pActualThread != NULL) TerminateThread(pSensorSim->m_pActualThread->m_hThread, 0);

        // RESET SOFT FLAG FOR STOPPING CURRENT FLAG
        pSensorSim->m_stopThreadSoft = FALSE;

        // RUN WORKER THREAD FOR EXECUTION
        pSensorSim->m_pActualThread = AfxBeginThread(CEACircuit::RunGACircuit, pThreadParam, THREAD_PRIORITY_LOWEST); 
    }
    else {
    	// RUN ON SELECTED REMOTE COMPUTER
	    pSensorSim->RunRemoteExecution(basicSettings.remoteConfig.actualRemoteHost, cfgScriptPath, "XX2");   
	}    
}


void CMeshTab::OnBnClickedExecuteFromtext()
{
    UpdateData(TRUE);

	int status = CEACircuit::ExecuteFromText(m_textInput);
}

void CMeshTab::OnBnClickedExecuteForInput()
{
    UpdateData(TRUE);
/*
    BASIC_INIT_DATA basicSettings;
    pSensorSim->GetBasicSettings(&basicSettings);
/**/
	int status = CEACircuit::ExecuteForInput(m_textInput, m_circuitInput);
/*
    int                         status = STAT_OK;
    DWORD                       circuit[MAX_GENOME_SIZE];    

    pSensorSim->m_pEACircuit->m_gaCirc.allocate();
    memset(circuit, 0, sizeof(circuit));
    CEACircuit::ParseCircuit(m_textInput, circuit, &(pSensorSim->m_pEACircuit->m_gaCirc.numLayers), &(pSensorSim->m_pEACircuit->m_gaCirc.internalLayerSize), &(pSensorSim->m_pEACircuit->m_gaCirc.outputLayerSize));
    
    CString     message;
    message.Format("\n\n###NumLayers: %d, InLayerSize: %d, OutLayerSize: %d, NumInputs: %d, NumOutputs: %d, NumTestSets: %d, TestSetSize: %d\n\n",pSensorSim->m_pEACircuit->m_gaCirc.numLayers, pSensorSim->m_pEACircuit->m_gaCirc.internalLayerSize, pSensorSim->m_pEACircuit->m_gaCirc.outputLayerSize, pSensorSim->m_pEACircuit->m_gaCirc.numInputs, pSensorSim->m_pEACircuit->m_gaCirc.numOutputs, NUM_TEST_SETS, pSensorSim->m_pEACircuit->m_gaCirc.numTestVectors); 
    LOG_INSERTSTRING(message); 
    
    // ACTUAL SIZE OF GENOM
    pSensorSim->m_pEACircuit->m_gaCirc.genomeSize = (pSensorSim->m_pEACircuit->m_gaCirc.numLayers * 2) * MAX_INTERNAL_LAYER_SIZE;
    GA1DArrayGenome<DWORD>      genome(MAX_GENOME_SIZE, CEACircuit::garng_fitness);
    
    for (int i = 0; i < pSensorSim->m_pEACircuit->m_gaCirc.genomeSize; i++) genome.gene(i, circuit[i]);    
    
    CEACircuit::PrintCircuit(genome);

    // COPY INPUT FOR EXECUTION
    BYTE    circInput[MAX_INPUTS];
    BYTE    circOutput[MAX_OUTPUTS];
    DWORD   numInputs = MAX_INPUTS;
    CCommonFnc::BYTE_ConvertFromHexStringToArray(m_circuitInput, circInput, &numInputs);
    memset(circOutput, 0, MAX_OUTPUTS);
    
    // EXECUTE CIRCUIT
    status = CEACircuit::ExecuteCircuit(&(pSensorSim->m_pEACircuit->m_gaCirc), &genome, circInput, circOutput);

    CCommonFnc::BYTE_ConvertFromArrayToHexString(circOutput, pSensorSim->m_pEACircuit->m_gaCirc.outputLayerSize, &message);
    LOG_INSERTSTRING(message); 
    
    CCommonFnc::BYTE_ConvertFromHexStringToArray(m_circuitInput, circInput, &numInputs);
/*    
    // PRINT HASH OF INPUT
    MD5_CTX mdContext;
    MD5_Init(&mdContext);
    MD5_Update(&mdContext, circInput, numInputs);
    MD5_Final(&mdContext);
    CCommonFnc::BYTE_ConvertFromArrayToHexString(mdContext.digest, MD5_DIGEST_LENGTH, &message);
    LOG_INSERTSTRING(message); 

	CSHA1 sha1;
    // SIGNALIZE SHA1 BY SETTING OUTPUT AS 0xff
    sha1.Input(circInput, numInputs);
    BYTE message_digest_array[20];
    sha1.Result(message_digest_array);
    CCommonFnc::BYTE_ConvertFromArrayToHexString(message_digest_array, 20, &message);
    LOG_INSERTSTRING(message); 
/**/
}




void CMeshTab::OnBnClickedCheck1()
{
    // TODO: Add your control notification handler code here
}


void CMeshTab::OnBnClickedAllFnc()
{
    UpdateData(TRUE);
        
    m_fncNOP = TRUE;
    m_fncOR = TRUE;
    m_fncAND = TRUE;
    m_fncXOR = TRUE;
    m_fncNOR = TRUE;
    m_fncNAND = TRUE;
    m_fncROTL = TRUE;
    m_fncROTR = TRUE;
    m_fncSUM = TRUE;
    m_fncSUBS = TRUE;
    m_fncADD = TRUE;
    m_fncMULT = TRUE;
    m_fncDIV = TRUE;
    m_fncCONST = TRUE;
    m_fncBSEL = TRUE;
            
    
    UpdateData(FALSE);
}

void CMeshTab::OnBnClickedNoFnc()
{
    UpdateData(TRUE);
        
    m_fncNOP = FALSE;
    m_fncOR = FALSE;
    m_fncAND = FALSE;
    m_fncXOR = FALSE;
    m_fncNOR = FALSE;
    m_fncNAND = FALSE;
    m_fncROTL = FALSE;
    m_fncROTR = FALSE;
    m_fncSUM = FALSE;
    m_fncSUBS = FALSE;
    m_fncADD = FALSE;
    m_fncMULT = FALSE;
    m_fncDIV = FALSE;
    m_fncCONST = FALSE;
    m_fncBSEL = FALSE;
            
    
    UpdateData(FALSE);
}

void CMeshTab::OnBnClickedRadio1()
{
    // TODO: Add your control notification handler code here
}

void CMeshTab::OnBnClickedSoftInterrupt()
{
    pSensorSim->m_stopThreadSoft = TRUE;
}


void CMeshTab::OnBnClickedDistinguisher()
{
    // TODO: Add your control notification handler code here
}

void CMeshTab::OnBnClickedEacTest()
{
	CEACircuit::TestEAC();
}
