#include "stdafx.h"
#include "RndGen.h"

CRndGen::CRndGen(DWORD seed) {
    InitRandomGenerator(seed);
}


int CRndGen::GetRandomFromInterval(DWORD highBound, DWORD *pRandom) {
    int     status = STAT_OK;

    // UPDATE ACCUMULATOR
    UpdateAccumulator();

    // GET FIRST DWORD FROM ACCUMULATOR     
    DWORD   random;
    memcpy(&random, m_md5Accumulator, sizeof(DWORD));
    if (pRandom) *pRandom = (DWORD) (((float) random / ULONG_MAX) *  highBound);

    return status;
}

int CRndGen::GetRandomFromInterval(BYTE highBound, BYTE *pRandom) {
    int     status = STAT_OK;
    DWORD   rand = 0;
    
    status = GetRandomFromInterval(highBound, &rand);
    *pRandom = (BYTE) rand;

    return status;
}

int CRndGen::GetRandomFromInterval(int highBound, int *pRandom) {
    int     status = STAT_OK;

    // UPDATE ACCUMULATOR
    UpdateAccumulator();

    // GET FIRST DWORD FROM ACCUMULATOR     
    int   random;
    memcpy(&random, m_md5Accumulator, sizeof(int));
    // SUPRESS NEGATIVE VALUES
    random = abs(random);
    if (pRandom) *pRandom = (int) (((float) random / INT_MAX) *  highBound);

    return status;
}

int CRndGen::GetRandomFromInterval(float highBound, float *pRandom) {
    int     status = STAT_OK;

    // UPDATE ACCUMULATOR
    UpdateAccumulator();

    // GET FIRST DWORD FROM ACCUMULATOR     
    DWORD   random;
    memcpy(&random, m_md5Accumulator, sizeof(DWORD));
    if (pRandom) *pRandom = (float) (((float) random / ULONG_MAX) *  highBound);

    return status;
}

int CRndGen::InitRandomGenerator(DWORD seed) {
    
    // IF SEED NOT EXTERNALLY SUPPLIED, TAKE SYSTEM TIME
    if (seed == 0) seed = (unsigned int) time(NULL);
    
    // INITIALIZE GENERATOR
    srand(seed);

    // INITIALIZE STARTUP MD5 ACUMULLATOR
    for (BYTE i = 0; i < MD5_DIGEST_LENGTH; i++) m_md5Accumulator[i] = rand() % 256;

    return STAT_OK;
}

int CRndGen::UpdateAccumulator() {
    MD5_CTX mdContext;
    //
    //  TODO: IF BETTER (PSEUDO) RANDOM GENERATOR IS AVAILABLE, JUST REPLACE HERE
    //  AND MODIFY InitRandomGenerator() FUNCTION
    //  NOW MD5 HASH WITH ACCUMULATOR IS USED
    //
    
    // UPDATE ACCUMULATOR
	MD5Init(&mdContext);
	MD5Update(&mdContext, m_md5Accumulator, MD5_DIGEST_LENGTH);
	MD5Final(&mdContext);
    memcpy(m_md5Accumulator, mdContext.digest, MD5_DIGEST_LENGTH);
    
    return STAT_OK;
}  
