#ifndef SSGLOBALS_H
#define SSGLOBALS_H

#include "..\Shared\status.h"
#include "ga\GAGenome.h"
#include "ga\GASStateGA.h"

// GENERAL LOGGING SERVICE
//#define LOG_INSERTSTRING        pSensorSim->Log_InsertString
/*
#define LOG_INSERTSTRING(message)               { char* log = new char[strlen(message)+1]; strncpy_s(log, strlen(message)+1, (LPCTSTR) message, strlen(message)); pSensorSim->PostMessage(WM_LOG_INSERTSTRING, (WPARAM) log, 1); }
#define LOG_INSERTSTRING_NOTIME(message, bTime) { char* log = new char[strlen(message)+1]; strncpy_s(log, strlen(message)+1, (LPCTSTR) message, strlen(message)); pSensorSim->PostMessage(WM_LOG_INSERTSTRING, (WPARAM) log, 2); }
#define LOG_APPENDSTRING(message)               { char* log = new char[strlen(message)+1]; strncpy_s(log, strlen(message)+1, (LPCTSTR) message, strlen(message)); pSensorSim->PostMessage(WM_LOG_INSERTSTRING, (WPARAM) log, 3); }
/**/
#define LOG_INSERTSTRING(message)               { if (pSensorSim->m_hWnd != NULL) {char* log = new char[strlen(message)+1]; strncpy_s(log, strlen(message)+1, (LPCTSTR) message, strlen(message)+1); pSensorSim->PostMessage(WM_LOG_INSERTSTRING, (WPARAM) log, 1);} }
#define LOG_INSERTSTRING_NOTIME(message, bTime) { char* log = new char[strlen(message)+1]; strncpy_s(log, strlen(message)+1, (LPCTSTR) message, strlen(message)+1); pSensorSim->PostMessage(WM_LOG_INSERTSTRING, (WPARAM) log, 2); }
#define LOG_APPENDSTRING(message)               { char* log = new char[strlen(message)+1]; strncpy_s(log, strlen(message)+1, (LPCTSTR) message, strlen(message)+1); pSensorSim->PostMessage(WM_LOG_INSERTSTRING, (WPARAM) log, 3); }

#define LOG_INSERTCLEARLINE                     { pSensorSim->PostMessage(WM_LOG_INSERTSTRING, 0, 4); }
#define LOG_INSERTSEPARATOR                     { pSensorSim->PostMessage(WM_LOG_INSERTSTRING, 0, 5); }

// define PERFTIME for performance monitor
// #define PERFTIME

#ifdef PERFTIME 
#define _PERFTIME_BEGIN_                        pSensorSim->perfNestLevel++; double perfTimeElapsed = -(double)read_tsc(); 
//pSensorSim->perfTimeString.Format("%d:begin:%s:%Lf", pSensorSim->perfNestLevel, __FUNCTION__, -perfTimeElapsed); pSensorSim->perfTimeList.push_back(pSensorSim->perfTimeString); 
#define _PERFTIME_END_                          perfTimeElapsed += (double)read_tsc(); pSensorSim->perfNestLevel--; pSensorSim->perfCallTime[__FUNCTION__] += perfTimeElapsed; pSensorSim->perfCallCounter[__FUNCTION__] += 1; 
//pSensorSim->perfTimeString.Format("%d:end:%s:%Lf", pSensorSim->perfNestLevel, __FUNCTION__, perfTimeElapsed); pSensorSim->perfTimeList.push_back(pSensorSim->perfTimeString); 
#else
#define _PERFTIME_BEGIN_    
#define _PERFTIME_END_
#endif



//struct SENSOR_NODE;
typedef DWORD KEY_ID; 


typedef struct _INT_DATA_BLOB {
    int*    pData;
    DWORD   dwMaxLen;
    DWORD   dwActLen;

    _INT_DATA_BLOB(void) {
        pData = NULL;
        dwMaxLen = 0;
        dwActLen = 0;
    }

} INT_DATA_BLOB;


typedef struct _EG_SCHEME {
    DWORD   keyPoolSize;
    int     keyRingSize;
    BYTE    qIntersect;
    BOOL    useIt;
    DWORD   maxComprNodes;      // maximum number of compromissed nodes by attacker
    DWORD   ringRepresentMethod;// representation method of keys in node's ring: 1) default, set of key ID (memeory efficient, slower) 2) bit mask of whole key pool (memory expensive, fast operations like find shared keys)
        
    _EG_SCHEME(void) {
        clear();
    }

    void clear() {
        keyPoolSize = 0;
        keyRingSize = 0;
        qIntersect = 0; 
        useIt = FALSE;       
        maxComprNodes = 0;
        ringRepresentMethod = FLAG_KEYRING_IDSET;
    }

} EG_SCHEME;

typedef struct _BASE_STATIONS {
	DWORD		bsCount;			// total number of base stations
	DWORD		bsActive;			// number of base stations active for one sensor
    BYTE        activeBSSelect;     // type of select rule of BS active for given sensor
    BYTE        bsPlacement;        // type of placement of BS in deployement area    

	_BASE_STATIONS(void) {
		clear();		
	}

    void clear() {
        bsCount = 0;
        bsActive = 0;
        activeBSSelect = 0;
        bsPlacement = 0;
    }
} BASE_STATIONS;

typedef struct _MMD_CONFIG {
	BYTE		routingStrategy;	// routing strategy used for message delivery between sensor and base station
	float		nextNeighDistance;	// suggested distance (ratio to maximum transmission strength) of next neigbour 

	_MMD_CONFIG(void) {
		clear();		
	}

    void clear() {
        routingStrategy = 0;
        nextNeighDistance = 0;
    }
} MMD_CONFIG;

typedef struct _RANDOM_GENERATOR {
    DWORD       randomSeed;
    BOOL        useFixedSeed;

    _RANDOM_GENERATOR(void) {
        clear();
    }

    void clear() {
        randomSeed = 0;
        useFixedSeed = FALSE;
    }

} RANDOM_GENERATOR;

typedef struct _FOE_CONFIG {
    BOOL        useLocalBoost;
    BOOL        useBoostAllDirectNeigh;
    DWORD       boostedNodesCount;
    DWORD       nodesInGroupCount;    
    DWORD       minKeysCount;
    BOOL        onlySenderTarget;
    BOOL        assumeSecureLink;
    BOOL        egAuth;

    _FOE_CONFIG(void) {
        clear();
    }

    void clear() {
        useLocalBoost = FALSE;
        useBoostAllDirectNeigh = FALSE;
        boostedNodesCount = 0;
        nodesInGroupCount = 0;
        minKeysCount = 0;
        onlySenderTarget = FALSE;
        assumeSecureLink = FALSE;
        egAuth = FALSE;
    }
} FOE_CONFIG;

typedef struct _BATCH_TEST_SETTINGS {
    DWORD       whatSaveFlags;      // what to save into file when executing tests
    DWORD       methodsFlags;       // what methods will be used   
    int         batchRepeat;        // repeat of batch test
    CString     outputPath;         // base output path
    CString     note;
    float       rangeFrom;
    float       rangeTo;
    float       rangeStep;

    _BATCH_TEST_SETTINGS(void) {
        clear();
    }

    void clear() {
        whatSaveFlags = 0;
        methodsFlags = 0;
        batchRepeat = 1;        
        outputPath = MATLAB_BASE_PATH;         
        rangeFrom = (float) 0.01;
        rangeTo = 1;
        rangeStep = (float) 0.03;
        note = "No note";
    }

} BATCH_TEST_SETTINGS;

typedef struct _NEIGHLEASH_CONFIG {
    float       dropMessageProb;    
    float       injectMessageProb;    
    float       changeMessageDestProb;    
    float       neighTransmitCheckProb;
    float       fractComprNodes;
    DWORD       transmitCheckFlags;

    _NEIGHLEASH_CONFIG(void) {
        clear();
    }

    void clear() {
        dropMessageProb = 0;    
        injectMessageProb = 0;     
        changeMessageDestProb = 0; 
        neighTransmitCheckProb = 0;
        fractComprNodes = 0;
        transmitCheckFlags = 0;
    }

} NEIGHLEASH_CONFIG;

typedef struct _REMOTE_CTRL_CONFIG {
	CString		remoteHosts;	
	CString     actualRemoteHost;

	_REMOTE_CTRL_CONFIG(void) {
		remoteHosts = "127.0.1:4001";
		actualRemoteHost = HOST_ACTUAL;
	}
	void clear() {
		remoteHosts = "";
	}
} REMOTE_CTRL_CONFIG;


typedef struct _LIST_NODE {
    void*         pItem;

    _LIST_NODE*   prev;           // previous LIST_NODE struct in list
    _LIST_NODE*   next;           // next LIST_NODE struct in list

    _LIST_NODE (void) {
        pItem = NULL;
        prev = NULL;
        next = NULL;
    }
 
} LIST_NODE;

typedef struct _DATA_LIST {
    LIST_NODE*  pFrontNode;
    LIST_NODE*  pBackNode;

    _DATA_LIST(void) {
        pFrontNode = NULL;
        pBackNode = NULL;
    }
    
    BOOL push_back(void* pItem) {
        if (pFrontNode == NULL) {
            pFrontNode = pBackNode = new LIST_NODE;
            pFrontNode->pItem = pItem;
        }
        else {
            pBackNode->next = new LIST_NODE;
            pBackNode->next->pItem = pItem;
            pBackNode->next->prev = pBackNode;
            pBackNode = pBackNode->next;
        }
        return TRUE;
    }
    BOOL push_front(void* pItem) {
        if (pFrontNode == NULL) {
            pFrontNode = pBackNode = new LIST_NODE;
            pFrontNode->pItem = pItem;
        }
        else {
            pFrontNode->prev = new LIST_NODE;
            pFrontNode->prev->pItem = pItem;
            pFrontNode->prev->next = pFrontNode;
            pFrontNode = pFrontNode->prev;
        }
        return TRUE;
    }
    
    void remove(LIST_NODE* pNode) {
        if (pNode) {
            // UPDATE REFERENCES FROM NEIGBOUR NODES 
            if (pNode->next != NULL) pNode->next->prev = pNode->prev;
            if (pNode->prev != NULL) pNode->prev->next = pNode->next;
            // UPDATE pFrontNode AND pBackNode IF NEEDED
            if (pNode == pFrontNode) pFrontNode = pNode->next;
            if (pNode == pBackNode) pBackNode = pNode->prev;

            delete pNode; 
        }
    }

    void release() {
        LIST_NODE*   pNode;
        LIST_NODE*   pNode2;
        pNode = pFrontNode;
        while (pNode != NULL) {
            pNode2 = pNode;
            pNode = pNode->next;

            delete pNode2;
        }

        pFrontNode = NULL;
        pBackNode = NULL;
    }
} DATA_LIST;

typedef struct _NEIGH_LIST_NODE {
    void*               pItem;
    
    float               dist;           // distance to neighbour (used only for neighbours list)  
    DWORD               keyFlags;            
    _LIST_NODE*         compromisedBy;  // pointer to first black node struct, which compromissed link key to this neighbour (if any)     
    
    _NEIGH_LIST_NODE*   prev;           // previous NEIGH_LIST_NODE struct in list
    _NEIGH_LIST_NODE*   next;           // next NEIGH_LIST_NODE struct in list

    KEY_ID              EG_sharedKeys[MAX_SHARED_KEYS]; // list of shared keys between neigbours

    _NEIGH_LIST_NODE (void) {
        pItem = NULL;
        prev = NULL;
        next = NULL;
        compromisedBy = NULL;
        dist = 0;
        keyFlags = 0;
        
        memset(EG_sharedKeys, 0, sizeof(KEY_ID) * MAX_SHARED_KEYS);
    }

    BOOL insertCompromising(void* pNode) {
        LIST_NODE*      pListNode;

        if (compromisedBy == NULL) {
            // INSERT FIRST NODE IN COMPROMISING LIST
            compromisedBy = new LIST_NODE;
            compromisedBy->pItem = pNode;
        }
        else {
            // APPEND AT THE END OF LIST 
            pListNode = compromisedBy;
            while (pListNode->next != NULL) {
                pListNode = pListNode->next;
            }                 
            
            pListNode->next = new LIST_NODE;
            pListNode->next->prev = pListNode;
            pListNode->next->pItem = pNode;
        }

        return TRUE;
    }

    DWORD getCompromissedCount() {
        LIST_NODE*  pNode;
        DWORD       count = 0;
        // RELEASE LIST OF ALL NODES (LIST STRUCTS ONLY), WHICH COMPROMISSED THIS ONE LINK KEY 
        pNode = compromisedBy;
        while (pNode != NULL) {
            count++;
            pNode = pNode->next;
        } 

        return count;
    }

    void releaseComprBy() {
        LIST_NODE*      pNode;
        LIST_NODE*      pNode2;
        // RELEASE LIST OF ALL NODES (LIST STRUCTS ONLY), WHICH COMPROMISSED THIS ONE LINK KEY 
        pNode = compromisedBy;
        while (pNode != NULL) {
            pNode2 = pNode;
            pNode = pNode->next;
            
            
            delete pNode2;
        } 

        compromisedBy = NULL;
    }

} NEIGH_LIST_NODE;

typedef DWORD KEYS_MASK;

typedef struct _BS_ROUTE_STRUCT {
    DWORD               bsID;       // base station ID
    float               dist;       // distance fro sensor to BS
    BOOL                active;     // is active base station for this sensor
    NEIGH_LIST_NODE*    forwardNode;// next node for message forwarding for this BS
    DWORD               hopsCount;  // number of hops to this BS
    DWORD               pathFlags;  // flags related to path between sensor and BS

    _BS_ROUTE_STRUCT(void) {
        clear();
    }

    void clear() {
        bsID = 0;
        dist = 0;
        active = FALSE;
        forwardNode = NULL;
        hopsCount = 0;
        pathFlags = 0;
    }

} BS_ROUTE_STRUCT;

typedef struct _SENSITIVE_OBJECT {
    DWORD   id;             // unique identificator
    DWORD   typeFlags;      // type of this object, currently FLAG_SENSITOBJECT_SIMPLEKEY, FLAG_SENSITOBJECT_COMPOSITEKEY, FLAG_SENSITOBJECT_MESSAGE, FLAG_SENSITOBJECT_CONTAINER
    DWORD   secFlags;       // security related flags, currently FLAG_SENSITOBJECTSEC_COMPROMISED
    DATA_LIST*  components; // pointer to list of component object, interpretation depends on object type. E.g. encryption key(s) for message, component keys for compoiste key, etc.    
    DATA_LIST*  content;    // content of nested object like key inside message etc.

    _SENSITIVE_OBJECT(void) {
        clear();
    }

    void clear() {
        id = 0;
        typeFlags = 0;
        secFlags = 0;
        components = NULL;
        content = NULL;
    }

    BOOL equal(_SENSITIVE_OBJECT* pObject) {
        if (id == pObject->id) return TRUE;
        else return FALSE;
    }

    void release() {
        components->release();    
        content->release();    
    }
} SENSITIVE_OBJECT;

//JK
typedef struct _GA_ROUTE {
	UINT	genomeSize;
	int		numRules;

	_GA_ROUTE(void) {
		clear();
	}
	void clear() {
		genomeSize=0;
		numRules=0;

	}
} GA_ROUTE;

//JK
class CMessage {

private:
	
public:
	CMessage() {}
};


//JK
class CBaseRouteStrat {

public:
	virtual int receiveMsg(CMessage* pMsg) {
		return STAT_OK;
	}
	virtual int timeProcess() {
		return STAT_OK;
	}
	virtual int generateEvent(int data) {
		return STAT_OK;
	}
	virtual int incomingToSend() {
		return STAT_OK;
	}

};






//typedef struct _SENSOR_NODE {
class SENSOR_NODE {
public:
    DWORD                   id;                  // unique identification
    DWORD                   flags;               // bit flags
    float                   transmRange;
    float                   receiveRangeRatio;   // NOTE: CURRENTLY USE ONLY FOR BLACK NODEs, WHITE ARE ASSUMED TO HAVE SAME TRANSMISSION AND RECEIVING RANGE (== 1)
    float                   cX;
    float                   cY;

    NEIGH_LIST_NODE*        whiteNeigh;          // first list node of neighbours (= sensors which can hear transmission of this sensor)
    NEIGH_LIST_NODE*        blackNeigh;          // first list node of neighbours (= sensors which can hear transmission of this sensor)
    DWORD                   numWhiteNeigh;
    DWORD                   numBlackNeigh;

    DWORD                   comprKeysCounter;    // valid only for black sensor, contains number of link keys, which are compromissed by this black sensor 

    // FOE KEYS STRUCTURES
    KEY_ID*                 keyRing;
    DWORD                   keyRingSize;
    KEYS_MASK*              keyRingMask;        // bit mask indicating ownership of the key
    DWORD                   keyRingMaskSize;      

    // SCRIPT STRATEGY KEYS AND MESSAGES
    DATA_LIST*    ssKeys;             // keys obtained during steps of script strategy
    DATA_LIST*    ssMessages;         // messages obtained during steps of script strategy

    BS_ROUTE_STRUCT*        routeTableBS;        // routing table, separate entry FOR EACH BS, contains next neighbour to which message will be forwarded for given BS

    // GENETIC STRATEGY MEMORY
    DWORD                   valueMem[256]; 
    DWORD                   valueMemSize; 

    //ROUTING
	//JK
    CBaseRouteStrat*		pRouteStrat;


    SENSOR_NODE(void) {
        clear();
    }

    void clear() {
        id = 0;
        transmRange = 0;
        whiteNeigh = NULL;
        blackNeigh = NULL;
        numWhiteNeigh = 0;
        numBlackNeigh = 0;
        receiveRangeRatio = 1;
        cX = 0;
        cY = 0;
        comprKeysCounter = 0;
        keyRing = NULL;
        keyRingSize = 0;
        keyRingMask = NULL;
        keyRingMaskSize = 0;
        routeTableBS = NULL;
        ssKeys = NULL;    
        ssMessages = NULL;
//        valueMem = NULL;
        valueMemSize = 256;
        memset(valueMem, 0, sizeof(DWORD) *  valueMemSize);
		pRouteStrat = NULL;
    }

	void setRouteStrat(CBaseRouteStrat* pRS) {
		pRouteStrat = pRS;
    }

    BOOL ss_addKey(SENSITIVE_OBJECT* pKey) {
        // ADD TO NODE'S RING
        if (!(pKey->typeFlags & FLAG_SENSITOBJECT_KEY)) ASSERT(FALSE);
        if (ssKeys == NULL) ssKeys = new DATA_LIST; 
        ssKeys->push_back(pKey);

        // ADD NODE TO GROUP OF THIS KEY'S OWNER
        pKey->components->push_back(this);

        return TRUE;
    }
    BOOL ss_addKeys(DATA_LIST* pKeysList) {
        BOOL    status = TRUE;
        LIST_NODE* pNode = pKeysList->pFrontNode;
        SENSITIVE_OBJECT*   pKey;
        while (pNode != NULL) {
            // EXTRACT ALL 'key' TYPE OBJECTS AND INSERT INTO LOCAL LIST
            if ((pKey = (SENSITIVE_OBJECT*) pNode->pItem) != NULL) {
                if (pKey->typeFlags & FLAG_SENSITOBJECT_KEY) {
                    if (ss_addKey(pKey) == FALSE) status = FALSE; 
                }
            }
            pNode = pNode->next;
        }

        return status;
    }
    BOOL ss_addMessage(SENSITIVE_OBJECT* pMessage) {
        if (!(pMessage->typeFlags & FLAG_SENSITOBJECT_MESSAGE)) ASSERT(FALSE);

        if (ssMessages == NULL) ssMessages = new DATA_LIST;
        ssMessages->push_back(pMessage);

        return TRUE;
    }
    BOOL ss_dispatchMessages() {
        BOOL    status = TRUE;
        BOOL    bNewKeysAdded = FALSE;

        // PROCESS ALL LOCALLY BUFFERED MESSAGES, AND EXTRACT KEYS IF POSSIBLE
        if (ssMessages != NULL) {
            LIST_NODE*  pNode;
            LIST_NODE*  pNode2;
            SENSITIVE_OBJECT*   pMessage;
            pNode = ssMessages->pFrontNode;
            while (pNode != NULL) {
                if ((pMessage = (SENSITIVE_OBJECT*) pNode->pItem) != NULL) {
                    // CHECK IF ALL USED KEYS ARE OWNED BY NODE
                    if (ss_haveAllKeysOfMessage(pMessage)) {
                        // ADD ALL KEYS FROM CONTENT
                        if (pMessage->content != NULL) {
                            if (ss_addKeys(pMessage->content) == FALSE) status = FALSE;
                            // NEW KEYS WERE ADDED => OTHER MESSAGES MIGHT BE DISPATCHABLE, RE-RUN      
                            bNewKeysAdded = TRUE;
                        }
                        // REMOVE MESSAGE FROM BUFFER
                        pNode2 = pNode;
                        pNode = pNode->next;
                        ssMessages->remove(pNode2);
                    }
                    else pNode = pNode->next;
                }
                else pNode = pNode->next;
            }
        }

        // NEW KEYS WERE ADDED => OTHER MESSAGES MIGHT BE DISPATCHABLE, RE-RUN      
        if (bNewKeysAdded) {
            if (ss_dispatchMessages() == FALSE) status = FALSE;
        }

        return status;
    }
    BOOL ss_haveAllKeysOfMessage(SENSITIVE_OBJECT* pMessage) {
        BOOL    haveAllKeys = TRUE;

        if (!(pMessage->typeFlags & FLAG_SENSITOBJECT_MESSAGE)) ASSERT(FALSE);
        

        return ss_haveAllKeys(pMessage->components);
    }
    BOOL ss_haveAllKeys(DATA_LIST* pKeys) {
        BOOL    haveAllKeys = TRUE;

        if (pKeys != NULL) {
            SENSITIVE_OBJECT*   pKey;
            LIST_NODE*  pNode;
            pNode = pKeys->pFrontNode;
            while (pNode != NULL) {
                if ((pKey = (SENSITIVE_OBJECT*) pNode->pItem) != NULL) {
                    if (!ss_haveKey(pKey)) {
                        // KEY IS MISSING
                        haveAllKeys = FALSE;    
                        break;
                    }
                }
                
                pNode = pNode->next;
            }
        }

        return haveAllKeys;
    }

    BOOL ss_haveKey(SENSITIVE_OBJECT* pKey) {
        BOOL                haveKey = FALSE;
        SENSITIVE_OBJECT*   pOwnedKey;
        LIST_NODE*          pNode;

        if (!(pKey->typeFlags & FLAG_SENSITOBJECT_KEY)) ASSERT(FALSE);
        pNode = ssKeys->pFrontNode;
        while (pNode != NULL) {
            if ((pOwnedKey = (SENSITIVE_OBJECT*) pNode->pItem) != NULL) {
                if (!(pOwnedKey->typeFlags & FLAG_SENSITOBJECT_KEY)) ASSERT(FALSE);
                if (pKey->equal(pOwnedKey)) {
                    // KEY FOUND
                    haveKey = TRUE;    
                    break;
                }
            }
            
            pNode = pNode->next;
        }
        
        return haveKey;
    }

    BOOL insertNeigh(SENSOR_NODE* pNode, float dist) {
        NEIGH_LIST_NODE*      pListNode;
		NEIGH_LIST_NODE*	  pListPrev=NULL;
        NEIGH_LIST_NODE**     ppNeigh;
		NEIGH_LIST_NODE*      newNode;

        if (pNode->flags & FLAG_SENSOR_WHITE) ppNeigh = &whiteNeigh;
        if (pNode->flags & FLAG_SENSOR_BLACK) ppNeigh = &blackNeigh;
        
        //ppNeigh = &whiteNeigh;  //TEST

		//WE CREATE THE NEW NODE
		newNode = new NEIGH_LIST_NODE;
		newNode->pItem = pNode;
		newNode->dist = dist;
		newNode->prev=NULL;
		newNode->next=NULL;

        if (*ppNeigh == NULL) {
            // INSERT FIRST NODE IN NEIGHBOUR LIST
            *ppNeigh = newNode;
        }
        else {
            // APPEND INTO LIST (SORTED BY DISTANCE)
            pListNode = *ppNeigh;
			int stop=0;
			while ((pListNode != NULL)&&(!stop)){
				if (pListNode->dist < dist) {
					pListPrev = pListNode;
					pListNode = pListNode->next;
				} else
					stop=1;
            }                 

            // INSERT NEW LIST NODE WITH PTR TO SENSOR INSIDE 
            if (pListNode == NULL) {
                // END OF LIST REACHED (INSERT TO END)
                pListPrev->next = newNode;
                newNode->prev = pListPrev;
            }
            else {
                if (pListPrev == NULL) {
                    // INSERT AS A FIRST NODE IN LIST
                    pListNode->prev = newNode;  
                    pListNode->prev->next = pListNode;
                    *ppNeigh = pListNode->prev;
                }
                else {
                    // NODE WITH LONGER DISTANCE REACHED (INSERT BEFORE)
                    pListPrev->next = newNode;
                    newNode->prev = pListPrev;
                    newNode->next = pListNode;
                    pListNode->prev = newNode;
                }
            }
        }

        if (pNode->flags & FLAG_SENSOR_WHITE) numWhiteNeigh++;
        if ((pNode->flags & FLAG_SENSOR_BLACK) && !(pNode->flags & FLAG_SENSOR_BLACK_INACTIVENEIGH)) numBlackNeigh++;

        return TRUE;
    }

    BOOL isWhiteNeigh(SENSOR_NODE* pNeigh, DWORD maxUsedNeigh = ULONG_MAX) {
        //_PERFTIME_BEGIN_
    
        NEIGH_LIST_NODE*      pNode;
        SENSOR_NODE*   pSensor;
        DWORD           usedNeigh;
        BOOL            bResult = FALSE;
        pNode = whiteNeigh;
        usedNeigh = 0;
        while ((pNode != NULL) && (usedNeigh < maxUsedNeigh)) {
            pSensor = (SENSOR_NODE*) pNode->pItem;

            if (pSensor->flags & FLAG_SENSOR_WHITE) {
                usedNeigh++;
                if (pSensor->id == pNeigh->id) {
                    bResult = TRUE;
                    break;
                }
            }

            pNode = pNode->next;
        } 
        
        //_PERFTIME_END_
        
        return bResult;
    }

    int markKeySecure(SENSOR_NODE* pNeigh, BOOL newly) {
        int             status = STAT_NO_SUCH_NEIGHBOUR;
        NEIGH_LIST_NODE*      pNode;
        SENSOR_NODE*   pSensor;

        pNode = whiteNeigh;
        while (pNode != NULL) {
            pSensor = (SENSOR_NODE*) pNode->pItem;

            if (pSensor->flags & FLAG_SENSOR_WHITE) {
                if (pSensor->id == pNeigh->id) {
                    if (newly) {
                        pNode->keyFlags |= FLAG_KEY_NEWLY_SECURE;
                    }
                    else {
                        pNode->keyFlags |= FLAG_KEY_SECURE;
                        pNode->keyFlags &= ~FLAG_KEY_COMPROMISED; 
                    }
                    status = STAT_OK;
                    break;
                }
            }
            pNode = pNode->next;
        } 
        
        return status;
    }

    int markKeyCompromised(SENSOR_NODE* pNeigh) {
        int             status = STAT_NO_SUCH_NEIGHBOUR;
        NEIGH_LIST_NODE*      pNode;
        SENSOR_NODE*   pSensor;

        pNode = whiteNeigh;
        while (pNode != NULL) {
            pSensor = (SENSOR_NODE*) pNode->pItem;

            if (pSensor->flags & FLAG_SENSOR_WHITE) {
                if (pSensor->id == pNeigh->id) {
                    pNode->keyFlags |= FLAG_KEY_COMPROMISED;
                    pNode->keyFlags &= ~FLAG_KEY_SECURE; 
                    status = STAT_OK;
                    break;
                }
            }

            pNode = pNode->next;
        } 
        
        return status;
    }

    inline NEIGH_LIST_NODE* getNeighStructKeyFlags(SENSOR_NODE* pNeigh) {
        NEIGH_LIST_NODE*    pNode;
        SENSOR_NODE*       pSensor;

        pNode = whiteNeigh;
        while (pNode != NULL) {
            pSensor = (SENSOR_NODE*) pNode->pItem;

            if (pSensor->flags & FLAG_SENSOR_WHITE) {
                if (pSensor->id == pNeigh->id) {
                    // NEIGH FOUND
                    return pNode;
                }
            }

            pNode = pNode->next;
        } 
        
        // NEIGHB NOT FOUND
        return NULL;
    }

    BOOL isBlackBeforeWhite(SENSOR_NODE* pWhiteNeigh, float* pBlackDist = NULL) {
        //_PERFTIME_BEGIN_

        BOOL            blackBeforeWhite = FALSE;
        SENSOR_NODE*   pSensor = NULL;
        SENSOR_NODE*   pComprSensor = NULL;
        NEIGH_LIST_NODE*    pListNode = NULL;
        NEIGH_LIST_NODE*    pComprListNode = NULL;
        float               blackDist = 0;

        // FIND FIRST BLACK NEIGBOUR AND ITS DISTANCE
        pListNode = blackNeigh;
        while (pListNode != NULL) {
            pSensor = (SENSOR_NODE*) pListNode->pItem;
            if ((pSensor->flags & FLAG_SENSOR_BLACK) && !(pSensor->flags & FLAG_SENSOR_BLACK_INACTIVENEIGH)) {
                // FIRST BLACK FOUND
                pComprSensor = pSensor;
                pComprListNode = pListNode;
                blackDist = pComprListNode->dist;
                if (pBlackDist) *pBlackDist = blackDist;
                break;    
            }
            pListNode = pListNode->next;
        }  

        // CHECK IF BLACK FOUND AND CHECK FOR DISTANCE OF pWhiteNeigh
        if (pComprSensor == NULL) {
            // NO BLACK SENSORS AT ALL
            blackBeforeWhite = FALSE;                
        }
        else {
            pListNode = whiteNeigh;
            while (pListNode != NULL) {
                pSensor = (SENSOR_NODE*) pListNode->pItem;
                if ((pSensor->flags & FLAG_SENSOR_WHITE) && (pWhiteNeigh->id == pSensor->id)) {
                    // REQUIRED WHITE NEIGHB FOUND
                    if (blackDist <= pListNode->dist) {
                        // BLACK BEFORE WHITE
                        blackBeforeWhite = TRUE;    
                    }
                    else {
                        // BLACK AFTER WHITE
                        blackBeforeWhite = FALSE;                
                    }

                    break;    
                }
                pListNode = pListNode->next;
            }  
        }

        //_PERFTIME_END_

        return blackBeforeWhite;
    }

    inline DWORD getValueMem(DWORD pos) {
        if (pos >= valueMemSize) return GAS_NO_VALUE;
        else return valueMem[pos];
    }   

    int setValueMem(DWORD pos, DWORD value) {
        if (pos >= valueMemSize) return -1;
        else valueMem[pos] = value;
        return 0;
    }   

    void release() {
        NEIGH_LIST_NODE* pNode;
        NEIGH_LIST_NODE* pNode2;
        // RELEASE ALL WHITE NEIGHBOUR LIST NODES (NOT SENSOR NODES STRUCT)
        pNode = whiteNeigh;
        while (pNode != NULL) {
            pNode2 = pNode;
            pNode = pNode->next;
            
            pNode2->releaseComprBy();
            delete pNode2;
        } 

        // RELEASE ALL BLACK NEIGHBOUR LIST NODES (NOT SENSOR NODES STRUCT)
        releaseBlackNeigh();

        // RELEASE KEYRING
        if (keyRing) delete[] keyRing;
        if (keyRingMask) delete[] keyRingMask;


        // RELEASE ROUTING TABLE
        if (routeTableBS) {
            delete[] routeTableBS;
            routeTableBS = NULL;
        }

        // RELEASE SCRIPT STRATEGY STRUCTURES
        if (ssKeys) ssKeys->release();
        ssKeys = NULL;
        if (ssMessages) ssMessages->release();
        ssMessages = NULL;
        
        
        //if (valueMem != NULL) delete[] valueMem;
        
        clear();
    }
    void releaseBlackNeigh() {
        NEIGH_LIST_NODE* pNode;
        NEIGH_LIST_NODE* pNode2;
        // RELEASE ALL BLACK NEIGHBOUR LIST NODES (NOT SENSOR NODES STRUCT)
        pNode = blackNeigh;
        while (pNode != NULL) {
            pNode2 = pNode;
            pNode = pNode->next;
            
            pNode2->releaseComprBy();
            delete pNode2;
        } 
        
        blackNeigh = NULL;
        numBlackNeigh = 0;
    }
}; 
//SENSOR_NODE;

//JK 
typedef list<CMessage*> lcmsg;

//JK
//Minimum Cost Forwarding
class CmcfMessage : public CMessage {

private:
	int type;
	SENSOR_NODE* source;
	SENSOR_NODE* destination;
	SENSOR_NODE* transmitter;
	SENSOR_NODE* receiver;
	int data;
	float cost;

	

public:
	CmcfMessage(int typ, SENSOR_NODE* s, SENSOR_NODE* d, SENSOR_NODE* t, SENSOR_NODE* r, int dat, float c) {
		type=typ;
		source=s;
		destination=d;
		transmitter=t;
		receiver=r;
		data=dat;
		cost = c;

	}

	CmcfMessage(CmcfMessage* m) {
		type=m->type;
		source=m->source;
		destination=m->destination;
		transmitter=m->transmitter;
		receiver=m->receiver;
		data=m->data;
		cost=m->cost;
	}

	int getData() {
		return data;
	}
	int setData(int d) {
		data = d;
		return STAT_OK;
	}
	float getCost() {
		return cost;
	}
	int setCost(float c) {
		cost = c;
		return STAT_OK;
	}
	int setSource(SENSOR_NODE* s) {
		source = s;
		return STAT_OK;
	}
	SENSOR_NODE* getSource() {
		return source;
	}
	int setDestination(SENSOR_NODE* d) {
		destination = d;
		return STAT_OK;
	}
	SENSOR_NODE* getDestination() {
		return destination;
	}
	int setReceiver(SENSOR_NODE* r) {
		receiver = r;
		return STAT_OK;
	}
	SENSOR_NODE* getReceiver() {
		return receiver;
	}
	int setTransmitter(SENSOR_NODE* t) {
		transmitter = t;
		return STAT_OK;
	}
	SENSOR_NODE* getTransmitter() {
		return transmitter;
	}
	int getType() {
		return type;
	}
	int setType(int t) {
		type = t;
		return STAT_OK;
	}

	

};

//JK
class CmcfRouteStrat : public CBaseRouteStrat {

#define MAX_COST 10000;
#define BEACON_TIMER 10;
#define MASTER_BEACON_TIMER 1000;
#define MESSAGE_TYPE_DATA 1
#define MESSAGE_TYPE_BEACON 2

private:
	SENSOR_NODE* pMe;
	DWORD myID;

	NEIGH_LIST_NODE* whiteNeigh;
	NEIGH_LIST_NODE* blackNeigh;

	float	myCost;				//distance from nextHop
	float cost;
	SENSOR_NODE* pNextHop;

	int	beaconTimer;
	int mBeaconTimer;

	lcmsg	lMsg;
    lcmsg   lIncMsg;

	CMessage* pMsgSent;
	CMessage* pMsgIncoming;
	CMessage* pMsgReceived;

	int msgTimer;
	int ctsTimer;
	int navTimer;
	int ortsWaitTimer;
	int difsTimer;

	bool messageToSend;
	bool carrierSense;

	
	
public:
	CmcfRouteStrat(SENSOR_NODE* me, NEIGH_LIST_NODE* wn, NEIGH_LIST_NODE* bn) {
		whiteNeigh = wn;
		blackNeigh = bn;
		pMe = me;
		myCost = 1;
		cost = MAX_COST
		pNextHop = NULL;
		mBeaconTimer = 0;
		beaconTimer = -1;

		if (pMe->flags&FLAG_SENSOR_BASE_STATION) //IS BS
		{
			myCost = 0;
			cost = 0;
		}

	}

	int timeProcess() {
		int status = STAT_OK;

		//IS BASE STATION
		if (pMe->flags&FLAG_SENSOR_BASE_STATION)  
		{
			if (mBeaconTimer>0) {
				mBeaconTimer--;
			}	else {
				sendBeacon();
				resetMBeaconTimer();
			}
		} else {
			if (beaconTimer>0) {
				beaconTimer--;
			} else {
				if (beaconTimer==0) {
					sendBeacon();
					beaconTimer=-1;
				}
			}
		}

		
		//PROCESS MESSAGES 
		status = processMessages();

		return status;
	}
	
	int receiveMsg(CMessage* pMsg) {
		int status=STAT_OK;

		lIncMsg.push_back(pMsg);

		return status;
	}


	int processMessages() {
		int status = STAT_OK;
		lcmsg::iterator  iter;
		CmcfMessage* pMsg;

		while(!(lMsg.empty())) {
			pMsg = (CmcfMessage*) lMsg.front();
			lMsg.pop_front();

			switch (pMsg->getType()) {
				case MESSAGE_TYPE_BEACON: {
					if (cost > pMsg->getCost()) {    //modify cost and next hop, better path found
						cost = pMsg->getCost();
						myCost = computeDist(pMe,pMsg->getSource());
						pNextHop = pMsg->getSource();

						CFile file;
						file.Open("c:\\vysledek.txt",CFile::modeReadWrite|CFile::modeNoTruncate|CFile::modeCreate);
						file.SeekToEnd();
						CString m;
						m.Format("BBBBBBBBBBB %d set nextHop to %d\n",(int)(pMe->id),(int)(pNextHop->id));
						file.Write((LPCTSTR)m,m.GetLength());
						file.Close();


						if (beaconTimer < 0) {
							resetBeaconTimer();
						}
					}

					break;
										  }
				case MESSAGE_TYPE_DATA: {
					if (pMe->id == pMsg->getReceiver()->id) {	//message for me
						if (pMe->flags & FLAG_SENSOR_BASE_STATION) // I AM BS
						{
							storeData(pMsg);
						} else {
							sendData(pMsg);
						}
					}
					break;
										}
			}
			delete pMsg;
		}
			
		return status;
	}
	
	int incomingToSend() {
		int status=STAT_OK;
		
		while(!(lIncMsg.empty())) {
			lMsg.push_back(lIncMsg.front());
			lIncMsg.pop_front();
		}

		return status;
	}
	int storeData(CmcfMessage* pMsg) {
		int status = STAT_OK;

		CFile file;
		file.Open("c:\\vysledek.txt",CFile::modeReadWrite|CFile::modeNoTruncate|CFile::modeCreate);
		file.SeekToEnd();
		CString m;
		m.Format("BS %d received data %d\n",(int)(pMe->id),pMsg->getData());
		file.Write((LPCTSTR)m,m.GetLength());
		file.Close();

		return status;
	}	
	int sendData(CmcfMessage* pMsgToSend) {
		int status = STAT_OK;
		NEIGH_LIST_NODE* pNodeList = whiteNeigh;
		SENSOR_NODE* pSensor;

		if (pNextHop!=NULL) {							//has next hop? else drop message
			while (pNodeList!=NULL) { 
				CmcfMessage* pMsg = new CmcfMessage(pMsgToSend);
				pMsg->setTransmitter(pMe);					//set myself as transmitter
				pMsg->setReceiver(pNextHop);				//set next hop as receiver
				pSensor = (SENSOR_NODE*) pNodeList->pItem;
				(pSensor->pRouteStrat)->receiveMsg(pMsg);
				pNodeList=pNodeList->next;
			}
		}

		return status;
	}

	int sendBeacon() {
		int status = STAT_OK;
		NEIGH_LIST_NODE* pNodeList = whiteNeigh;
		SENSOR_NODE* pSensor;

		while (pNodeList!=NULL) { 
		    CmcfMessage* pMsg = new CmcfMessage(MESSAGE_TYPE_BEACON,pMe,NULL,NULL,NULL,0,cost+myCost);
			pSensor = (SENSOR_NODE*) pNodeList->pItem;
			(pSensor->pRouteStrat)->receiveMsg(pMsg);
			pNodeList=pNodeList->next;
		}
		return status;
	}

	int resetMBeaconTimer() {
		mBeaconTimer = MASTER_BEACON_TIMER;
		return STAT_OK;
	}

	int resetBeaconTimer() {
		beaconTimer = BEACON_TIMER;
		return STAT_OK;
	}

	float computeDist(SENSOR_NODE* pSensor,SENSOR_NODE* pSensor2) {
			return ((float) sqrt(pow(pSensor->cX - pSensor2->cX, 2) + pow(pSensor->cY - pSensor2->cY, 2)));
	}

	int generateEvent(int data) {

		CmcfMessage *pMsg = new CmcfMessage(MESSAGE_TYPE_DATA, pMe,NULL,pMe,pMe,data,0);
		lMsg.push_back(pMsg);


		CFile file;
		int stat = file.Open("C:\\vysledek.txt",CFile::modeReadWrite|CFile::modeCreate|CFile::modeNoTruncate);
		file.SeekToEnd();
		CString m;
		m.Format("Node %d generate data %d\n",(int)(pMe->id),data);
		file.Write((LPCTSTR)m,m.GetLength());
		file.Close();
		
		
		

		return STAT_OK;
	}

};





/*
//ROUTING

class CMessage {

private:
	int type;
	int duration;
	SENSOR_NODE* source;
	SENSOR_NODE* destination;
	SENSOR_NODE* transmitter;
	SENSOR_NODE* receiver;
	int data;

public:
	CMessage() {}

	CMessage(int typ,int dur, SENSOR_NODE* s, SENSOR_NODE* d, SENSOR_NODE* t, SENSOR_NODE* r, int dat) {
		duration=dur;
		type=typ;
		source=s;
		destination=d;
		transmitter=t;
		receiver=r;
		data=dat;
	}

	CMessage(CMessage* m) {
		duration=m->duration;
		type=m->type;
		source=m->source;
		destination=m->destination;
		transmitter=m->transmitter;
		receiver=m->receiver;
		data=m->data;
	}

	int setSource(SENSOR_NODE* s) {
		source = s;
		return STAT_OK;
	}
	SENSOR_NODE* getSource() {
		return source;
	}
	int setDestination(SENSOR_NODE* d) {
		destination = d;
		return STAT_OK;
	}
	SENSOR_NODE* getDestination() {
		return destination;
	}
	int setReceiver(SENSOR_NODE* r) {
		receiver = r;
		return STAT_OK;
	}
	SENSOR_NODE* getReceiver() {
		return receiver;
	}
	int setTransmitter(SENSOR_NODE* t) {
		transmitter = t;
		return STAT_OK;
	}
	SENSOR_NODE* getTransmitter() {
		return transmitter;
	}
	int getType() {
		return type;
	}
	int setType(int t) {
		type = t;
		return STAT_OK;
	}
	int getDuration() {
		return delay;
	}
	int setDuration(int d) {
		delay = d;
		return STAT_OK;
	}

	~CMessage();

};

typedef list<CMessage*> lcms;
//IGF ROUTING

class CigfRouteStrat : public CBaseRouteStrat {

#define QUEUE_SIZE 4
#define ORTS_WAIT_TIME 10
#define DIFS 15
#define MESSAGE_TYPE_ORTS 1
#define MESSAGE_TYPE_CTS 2 
#define MESSAGE_TYPE_DATA 3
#define MESSAGE_TYPE_ACK 4
#define TRANS_DURATION 50

	
	
    lcms      msgToSend;
	CMessage* pMsgToSend;
	CMessage* pMsgSent;
	CMessage* pMsgIncoming;
	CMessage* pMsgReceived;

	int msgTimer;
	int ctsTimer;
	int navTimer;
	int ortsWaitTimer;
	int difsTimer;

	bool messageToSend;
	bool carrierSense;
    
	SENSOR_NODE* nextHopP;
	SENSOR_NODE* ortsSourceP;

	DWORD myID;
	SENSOR_NODE* myP;

	NEIGH_LIST_NODE* whiteNeigh;
	NEIGH_LIST_NODE* blackNeigh;
	BASE_STATIONS_LIST* baseStat;


public:
	CigfRouteStrat(DWORD id,SENSOR_NODE* me, NEIGH_LIST_NODE* wn, NEIGH_LIST_NODE* bn, BASE_STATIONS_LIST* bs) {
		whiteNeigh = wn;
		blackNeigh = bn;
		baseStat = bs;
		ctsTimer=-1;
		navTimer=0;
		ortsWaitTimer=-1;
		difsTimer=-1;
		msgTimer=-1;
		carrierSense = FALSE;
		messageToSend = FALSE;
		myID = id;
		myP = me;
		nextHopID=0;
		ortsSourceID=0;

		pMsgToSend=NULL;
		pMsgSent=NULL;
		pMsgIncoming=NULL;
	}

	int timeProcess() {
        int status=STAT_OK;
        // DECREASE ALL TIMERS
		if (ctsTimer>0) {
		   ctsTimer--;
		}
		if (navTimer>0) {
		   navTimer--;
		}
		if (ortsWaitTimer>0) {
		   ortsWaitTimer--;
		}
		if (difsTimer>0) {
			difsTimer--;
		}
		if (msgTimer>0) {
			msgTimer--;
		}

		//Carrier sense
		if (carrierSense) {
			if ((difsTimer==0)&&(navTimer==0)) {
				status = sendORTS();
				carrierSense  = FALSE;
				resetORTSWaitTimer();
			}
		} 
		//Send data message
		if (messageToSend) {
			status = sendData();
			messageToSend = FALSE;
		}
		
		if (ortsWaitTimer==0) {
			//re-transmitt
			status = sendORTS();
			resetORTSWaitTimer();
		} 
		if (ctsTimer==0) {
			//send CTS
			status = sendCTS();
			setCtsTimer(-1);
		}
		//incoming message?
		if (msgTimer==0) {
			status = processMessage();
			setMsgTimer(-1);
		}

        return status;
	}
	
	int processMessage() {
		int status = STAT_OK;
	
		pMsg = pMsgIncoming;
		pMsgIncoming = NULL;

		switch (pMsg->getType()) {
			case MESSAGE_TYPE_DATA: {
				status = processData(pMsg);
				break;
									}
			case MESSAGE_TYPE_ORTS: {
				if (isInForwArea()) {
					setCtsTimer(calculateWait());
				} else {
					if (pMsgReceived->getDelay() > navTimer) {
						setNavTimer(pMsgReceived->getDelay());       // modify duration
					}
				}
				break;
									}
			case MESSAGE_TYPE_CTS: {
				if (pMsgReceived->getDelay() > navTimer) {
					setNavTimer(pMsgReceived->getDelay());
				}									    // modify duration
				clearCtsTimer();
				break;
									}
			case MESSAGE_TYPE_ACK: {
					//ACK TIMER
				if (pMsgReceived->getDelay() > navTimer) {
					setNavTimer(pMsgReceived->getDelay());
				}
				break;
								   }
		}

		return status;
	}
	int processData(CMessage* pMsg) {
		int status = STAT_OK;

		pMsgReceived = pMsgIncoming;
		pMsgIncoming = NULL;
		if (pMsgReceived->getDestination()->id == myID) { //Message is for this node
					status = receiveMessage();
					status = sendAck();
				} else {
					if (pMsgReceived->getReceiver()->id == myID) {   //this node have to transmit this message
						pMsgToSend = new CMessage(pMsgReceived);
						status = sendAck();
						carrierSense = TRUE;
					} else {               //message for someone else
						if (pMsgReceived->getDelay() > navTimer) {
							setNavTimer(pMsgReceived->getDelay());
						}
					}
				}

	}
	int receiveMessage() {
		int status = STAT_OK;

		return status;
	}
	int calculateWait() {
		//TBD
		return 10;
	}
	
	int incomingMsg(CMessage* pMsg) {

		if (pMsgIncoming!=NULL) {
			pMsgIncoming->~CMessage();
            pMsgIncoming=NULL; //COLISION
			setMsgTimer(-1);
		} else {
			pMsgIncoming=pMsg;
			resetMsgTimer();
		}


        return STAT_OK;
	}

	float computeDist(SENSOR_NODE* pSensor,SENSOR_NODE* pSensor2) {
			return ((float) sqrt(pow(pSensor->cX - pSensor2->cX, 2) + pow(pSensor->cY - pSensor2->cY, 2)));
	}

	int generateEvent() {
		//TBD
		return STAT_OK;
	}

	bool isInForwArea() {
		//TBD
		return TRUE;
	}
	//Setting timers
	int resetORTSWaitTimer() {
		ortsWaitTimer=ORTS_WAIT_TIME;
		return STAT_OK;
	}
	int resetMsgTimer() {
		msgTimer=TRANS_DURATION;
		return STAT_OK;
	}
	int setMsgTimer(int msgT) {
		msgTimer = msgT;
	}
	int setORTSWaitTimer(int ortsWT) {
        ortsWaitTimer = ortsWT;
		return STAT_OK;
	}
	int setNavTimer(int navT) {
		navTimer=navT;
		return STAT_OK;
	}
	int clearCtsTimer() {
		ctsTimer=-1;
	}
	int setCtsTimer(int ctsT) {
		ctsTimer=ctsT;
		return STAT_OK;
	}
	//Sending messages
    int sendORTS() {
        int status;
		NEIGH_LIST_NODE* pNodeList = whiteNeigh;
		SENSOR_NODE* pSensor;

		while (pNodeList!=NULL) {
			//set delay
			int dist = (int) (TIME_CONST*myP->transmRange);
			dist = 4 * dist; 
 
		    CMessage* pMsg = new CMessage(MESSAGE_TYPE_ORTS,dist,myP,NULL,NULL,NULL,0);
			pSensor = (SENSOR_NODE*) pNodeList->pItem;
			(pSensor->pRouteStrat)->incomingMsg(pMsg);
			pNodeList=pNodeList->next;
		}
		pMsgReceived->~CMessage();
		pMsgReceived = NULL;
		return status;
	}
	int sendCTS() {
		int status;
		NEIGH_LIST_NODE* pNodeList = whiteNeigh;
		SENSOR_NODE* pSensor;

		while (pNodeList!=NULL) {
			//set duration
			int dist = (int) (TIME_CONST * ceil(computeDist(myP,pMsgReceived->getSource())));
			dist = pMsgReceived->getDelay() - dist;   //duration is duration from ORTS - dist
			CMessage* pMsg = new CMessage(MESSAGE_TYPE_CTS,dist,myP,pMsgReceived->getSource(),NULL,NULL,0);
			pSensor = (SENSOR_NODE*) pNodeList->pItem;
			(pSensor->pRouteStrat)->incomingMsg(pMsg);
			pNodeList=pNodeList->next;
			}
		pMsgReceived->~CMessage();
		pMsgReceived = NULL;
		return status;
	}
	int sendData() {
		int status = STAT_OK;
		NEIGH_LIST_NODE* pNodeList = whiteNeigh;
		SENSOR_NODE* pSensor;

		if (pMsgToSend!=NULL) {
			CMessage* pMsg = new CMessage(pMsgToSend);
			pMsg->setTransmitter(myP);    // set myself as a transmitter
			pMsg->setReceiver(pMsgReceived->getSource());  //set receiver of data as source of the CTS msg 
			//set duration
			int dist = (int)(TIME_CONST * ceil(computeDist(pMsg->getTransmitter(),pMsg->getReceiver())); //duration will be equal to distance
			dist = pMsgReceived->getDuration() - dist;  // set as a duration field from CTS - duration of data transfer
			pMsg->setDuration(dist); 
            
			//send
			while (pNodeList!=NULL) {
				CMessage* pM = new CMessage(pMsg);       // create new instance of message
				pSensor = (SENSOR_NODE*) pNodeList->pItem;
				(pSensor->pRouteStrat)->incomingMsg(pM); // send
				pNodeList=pNodeList->next;
			}
			pMsgSent->~CMessage(); // erase previous sent message
			pMsgSent = pMsg;       // store for resending
			pMsgToSend->~CMessage(); // free sent msg
			pMsgToSend=NULL;
			}
		 pMsgReceived->~CMessage();
		 pMsgReceived = NULL;
		return status;
	}
	int sendAck() {
		int status=STAT_OK;
        NEIGH_LIST_NODE* pNodeList = whiteNeigh;
		SENSOR_NODE* pSensor;

		while (pNodeList!=NULL) {
				//set duration
				int dist = (int)(TIME_CONST * ceil(computeDist(myP,pMsgReceived->getTransmitter()))); //duration equals distance
				dist = pMsgReceived->getDuration() - dist;   // compute duration as Duration from DATA - transmission time of ack
				CMessage* pMsg = new CMessage(MESSAGE_TYPE_ACK,dist,myP,pMsgReceived->getTransmitter(),NULL,NULL,0);

				pSensor = (SENSOR_NODE*) pNodeList->pItem;
				(pSensor->pRouteStrat)->incomingMsg(pMsg);
				pNodeList=pNodeList->next;
			}
		pMsgReceived->~CMessage();
		pMsgReceived = NULL;

		return status;
	}
};
/**/
typedef struct _BASE_STATIONS_LIST {
    DWORD           itemCount;
    SENSOR_NODE**   bs;

    _BASE_STATIONS_LIST(void) {
        clear();
    }
    
    void release() {
        if (bs != NULL) {
            delete[] bs;
            clear();
        }
    }


    void clear() {
        bs = NULL;
        itemCount = 0;
    }

} BASE_STATIONS_LIST;

typedef struct _GEO_GRID {
    float           cellSize;
    DWORD           numCellX;
    DWORD           numCellY;
    
    NEIGH_LIST_NODE***    grid;       // 2D geographic grid with pointers to sensor node 

    _GEO_GRID(void) {
        clear();
    }

    void clear() {
        cellSize = 0;
        numCellX = 0;
        grid = NULL;
    }

    void release() {
        // RELEASE NODES STRUCT IN EACH CELL
        if ((numCellX > 0) && (numCellY > 0) && (grid != NULL) ) { 
            NEIGH_LIST_NODE*    pNode;
            NEIGH_LIST_NODE*    pNode2;

            for (DWORD i = 0; i < numCellX; i++) {
                for (DWORD j = 0; j < numCellY; j++) {
                    // RELEASE ALL LIST NODES POSITIONED IN CELL [i, j]
                    pNode = grid[i][j];
                    while (pNode != NULL) {
                        pNode2 = pNode;
                        pNode = pNode->next;
                        delete pNode2;
                    } 
                }

                delete[] grid[i];
            }

            delete[] grid;

            clear();
        }
    }

    BOOL insertNode(SENSOR_NODE* pNode) {
        DWORD cellX = (DWORD) (pNode->cX / cellSize); 
        DWORD cellY = (DWORD) (pNode->cY / cellSize); 
        NEIGH_LIST_NODE*      pListNode;

        if ((cellX < numCellX) && (cellY < numCellY)) {
            if (grid[cellX][cellY] == NULL) {
                // INSERT FIRST NODE IN GRID
                grid[cellX][cellY] = new NEIGH_LIST_NODE;
                grid[cellX][cellY]->pItem = pNode;
            }
            else {
                // APPEND AT THE END OF LIST
                pListNode = grid[cellX][cellY];
                while (pListNode->next != NULL) {
                    pListNode = pListNode->next;
                }                 

                // INSERT NEW LIST NODE WITH PTR TO SENSOR INSIDE 
                pListNode->next = new NEIGH_LIST_NODE;
                pListNode->next->prev = pListNode;
                pListNode->next->pItem = pNode;
            }
        }
        else return FALSE;

        return TRUE;
    }
    
    BOOL removeNode(SENSOR_NODE* pNode) {
        DWORD cellX = (DWORD) (pNode->cX / cellSize); 
        DWORD cellY = (DWORD) (pNode->cY / cellSize); 
        NEIGH_LIST_NODE*      pListNode;

        if ((cellX < numCellX) && (cellY < numCellY)) {
            if (grid[cellX][cellY] == NULL) {
                // NO SUCH NODE EXISTS
            }
            else {
                // SEARCH FOR GIVEN NODE
                pListNode = grid[cellX][cellY];
                while (pListNode->next != NULL) {
                    if (pListNode->pItem == pNode) {
                        break;
                    } 
                    else pListNode = pListNode->next;
                }                 
                // UPDATE REFERENCES 
                if (pListNode->pItem == pNode) {
                    if (pListNode->next != NULL) pListNode->next->prev = pListNode->prev;
                    if (pListNode->prev != NULL) pListNode->prev->next = pListNode->next;

                    // UPDATE FIRST POINTER, IF RESPECTIVE NODE WAS DELETED
                    if (pListNode == grid[cellX][cellY]) {
                        // WE ARE GOING TO REMOVE FIRST NODE, SET NEXT ONE AS FIRST
                        grid[cellX][cellY] = pListNode->next;
                        if (grid[cellX][cellY] != NULL) ASSERT(grid[cellX][cellY]->prev == NULL);
                    }
/*
                    // CLEAR GRID CELL IF ONLY LAST ONE NODE WAS PRESENT
                    if (pListNode == grid[cellX][cellY] && pListNode->next == NULL) {
                        grid[cellX][cellY] = NULL;
                    }
/**/                    
                    delete pListNode; 
                    ASSERT(grid[cellX][cellY] != (NEIGH_LIST_NODE*) 0xfeeefeee);
                    pListNode = NULL;
                }
            }
        }
        else return FALSE;

        return TRUE;
    }

} GEO_GRID;

typedef struct _SENSOR_LIST {
    DWORD           numSensors;

    SENSOR_NODE**   sensors; 

    _SENSOR_LIST(void) {
        clear();
    }

    void clear() {
        sensors = NULL;
        numSensors = 0;
    }

    void release() {
        if (sensors != NULL) {
            for (DWORD i = 0; i < numSensors; i++) {
                if (sensors[i] != NULL) {
                    sensors[i]->release();
                    
                    delete sensors[i];
                    sensors[i] = NULL;
                }
            }

            delete[] sensors;
            clear();
        }
    }

    BOOL insertNeighbourNode(DWORD parentID, SENSOR_NODE* pNeighNode, float dist) {
        if ((parentID < numSensors) || (sensors[parentID] != NULL)) {
            sensors[parentID]->insertNeigh(pNeighNode, dist);
        }
        else return FALSE;

        return TRUE;
    }

    void clearLinkKeysStatus() {
        DWORD               i;
        SENSOR_NODE*        pSensor;
        NEIGH_LIST_NODE*    pListNode;   

        for (i = 0; i < numSensors; i++) {
            pSensor = sensors[i];
            pSensor->comprKeysCounter = 0;

            // WHITE NODES
            pListNode = pSensor->whiteNeigh;

            while (pListNode != NULL) {
                // CLEAR LINK KEY FLAGS 
                pListNode->keyFlags = 0;
                
                // CLEAR LIST OF COMPROMISSING KEYS
                pListNode->releaseComprBy();

                pListNode = pListNode->next;
            }
        }
    }

    void clearInactiveNeighFlags() {
        DWORD               i;

        for (i = 0; i < numSensors; i++) {
            sensors[i]->flags &= ~FLAG_SENSOR_BLACK_INACTIVENEIGH;
        }
    }

} SENSOR_LIST;

typedef struct _FOE_MESSAGE_LIST_NODE {
    LIST_NODE*      pNodesOnPath;             // nodes that are passed on message's path 
    DWORD           numberNodesOnPath;        // size of pNodesOnPath 
    SENSOR_NODE*    pSenderNode;              // origin of message      
    SENSOR_NODE*    pTargetNode;              // receiver of message          
    DWORD           numberOfHopsToBS;         // number of hops before reaching BS
    DWORD           numberOfHopsToCapture;    // number of hops before message is captured
    DWORD           numberOfKeys;             // number of applied onion keys  
    DWORD           numberOfUsedLocalBoostNeigh; // number of local neigbours, which were used during FOE local boost
    DWORD           flags;                      
    
    KEYS_MASK*      pAppliedKeysMask;          // bit mask indicating which keys were applied 
    DWORD           appliedKeysMaskCount;
    KEY_ID*         pAppliedKeysID;            // array of key id indicating which keys were applied
    DWORD           appliedKeysIDCount;

    _FOE_MESSAGE_LIST_NODE*   prev;           // previous LIST_NODE struct in list
    _FOE_MESSAGE_LIST_NODE*   next;           // next LIST_NODE struct in list

    _FOE_MESSAGE_LIST_NODE (void) {
        clear();
    }

    void clear() {
        pNodesOnPath = NULL;
        prev = NULL;
        next = NULL;
        pSenderNode = NULL;
        pTargetNode = NULL;
        numberOfHopsToBS = 0;
        numberOfHopsToCapture = 0;
        numberOfKeys = 0;
        numberOfUsedLocalBoostNeigh = 0;
        flags = 0;
        pAppliedKeysMask = NULL;
        appliedKeysMaskCount = 0;
        numberNodesOnPath = 0;
        pAppliedKeysID = NULL;
        appliedKeysIDCount = 0;
    }

    BOOL insertNode(void* pNode) {
        LIST_NODE*      pListNode;

        if (pNodesOnPath == NULL) {
            // INSERT FIRST NODE IN COMPROMISING LIST
            pNodesOnPath = new LIST_NODE;
            pNodesOnPath->pItem = pNode;
        }
        else {
            // APPEND AT THE END OF LIST 
            pListNode = pNodesOnPath;
            while (pListNode->next != NULL) {
                pListNode = pListNode->next;
            }                 
            
            pListNode->next = new LIST_NODE;
            pListNode->next->prev = pListNode;
            pListNode->next->pItem = pNode;
        }

        numberNodesOnPath++;
         
        return TRUE;
    }

    void release() {
        LIST_NODE*      pNode;
        LIST_NODE*      pNode2;
        // RELEASE LIST OF ALL NODES (LIST STRUCTS ONLY)(NOT SENSORS ITSELF)
        pNode = pNodesOnPath;
        while (pNode != NULL) {
            pNode2 = pNode;
            pNode = pNode->next;
            
            delete pNode2;
        } 

        pNodesOnPath = NULL;

        if (pAppliedKeysMask != NULL) delete[] pAppliedKeysMask;
        appliedKeysMaskCount = 0;
        if (pAppliedKeysID != NULL) delete[] pAppliedKeysID;
        appliedKeysIDCount = 0;
    }


} FOE_MESSAGE_LIST_NODE;




typedef struct _MMD_TEST_RESULTS {
    DWORD       foundPaths;
    DWORD       notFoundPaths;
    float       avgHops;
    DWORD       totalMessages;
    float       secureMessages;
    float       comprMessages;
    float       lostMessages;

    _MMD_TEST_RESULTS(void) {
        clear();
    }

    void clear() {
        foundPaths = 0;
        notFoundPaths = 0;
        avgHops = 0;
        totalMessages = 0;
        secureMessages = 0;
        comprMessages = 0;   
        lostMessages = 0; 
    }

} MMD_TEST_RESULTS;

typedef struct _FOE_TEST_RESULTS {
    DWORD       comprMsg;
    DWORD       secureMsg;
    DWORD       notCapturedMsg;
    DWORD       capturedMsg;
    float       avgHopsToBS;
    float       avgHopsToCapture;
    float       avgAppliedKeys;
    DWORD       comprNodes;
    DWORD       comprKeys;
    DWORD       maxHopsToBS;
    INT_DATA_BLOB   hopsToCaptureCounts;
    INT_DATA_BLOB   hopsToBSCounts;
    INT_DATA_BLOB   numComprOnHop;
    INT_DATA_BLOB   numAppliedKeysCounts;
    

    _FOE_TEST_RESULTS(void) {
        clear();
    }

    void clear() {
        comprMsg = 0;
        secureMsg = 0;
        notCapturedMsg = 0;
        capturedMsg = 0;
        avgHopsToBS = 0;
        avgHopsToCapture = 0;
        avgAppliedKeys = 0;
        comprNodes = 0;
        comprKeys = 0;
        maxHopsToBS = 0;
        if (hopsToCaptureCounts.pData) memset(hopsToCaptureCounts.pData, 0, sizeof(int) * hopsToCaptureCounts.dwMaxLen);
        if (hopsToBSCounts.pData) memset(hopsToBSCounts.pData, 0, sizeof(int) * hopsToBSCounts.dwMaxLen);
        if (numComprOnHop.pData) memset(numComprOnHop.pData, 0, sizeof(int) * numComprOnHop.dwMaxLen);
        if (numAppliedKeysCounts.pData) memset(numAppliedKeysCounts.pData, 0, sizeof(int) * numAppliedKeysCounts.dwMaxLen);
    }

} FOE_TEST_RESULTS;

typedef struct _NLEASH_TEST_RESULTS {
    DWORD       droppMsgDetected;
    DWORD       droppMsgNotDetected;
    DWORD       maxHopsToTarget;
    DWORD       minHopsToTarget;
    float       avgHopsToTarget;
    float       avgNeighBeforeNextRouting;
    float       avgNeighDetecting;
    DWORD       deliveredMsgCount;    
    DWORD       notDeliveredMsgCount; 
/*
    DWORD       notCapturedMsg;
    DWORD       capturedMsg;
    float       avgHopsToBS;
    float       avgHopsToCapture;
    float       avgAppliedKeys;
    DWORD       comprNodes;
    DWORD       comprKeys;
    INT_DATA_BLOB   hopsToCaptureCounts;
    INT_DATA_BLOB   hopsToBSCounts;
    INT_DATA_BLOB   numComprOnHop;
    INT_DATA_BLOB   numAppliedKeysCounts;
/**/    

    _NLEASH_TEST_RESULTS(void) {
        clear();
    }

    void clear() {
        droppMsgDetected = 0;
        droppMsgNotDetected = 0;
        maxHopsToTarget = 0;
        minHopsToTarget = 0;
        avgHopsToTarget = 0;
        deliveredMsgCount = 0;
        notDeliveredMsgCount = 0;
        avgNeighBeforeNextRouting = 0;
        avgNeighDetecting = 0;
/*
        avgHopsToBS = 0;
        avgHopsToCapture = 0;
        avgAppliedKeys = 0;
        comprNodes = 0;
        comprKeys = 0;
        if (hopsToCaptureCounts.pData) memset(hopsToCaptureCounts.pData, 0, sizeof(int) * hopsToCaptureCounts.dwMaxLen);
        if (hopsToBSCounts.pData) memset(hopsToBSCounts.pData, 0, sizeof(int) * hopsToBSCounts.dwMaxLen);
        if (numComprOnHop.pData) memset(numComprOnHop.pData, 0, sizeof(int) * numComprOnHop.dwMaxLen);
        if (numAppliedKeysCounts.pData) memset(numAppliedKeysCounts.pData, 0, sizeof(int) * numAppliedKeysCounts.dwMaxLen);
/**/        
    }

} NLEASH_TEST_RESULTS;

typedef struct _VALUE_INFO {
    BYTE    type;
    BYTE    flags;    
    DWORD   valueID;
    DWORD   subValueID1; 
    DWORD   subValueID2; 
    
    _VALUE_INFO(void) {
        clear();
    }
    
    void clear() {
        type = 0;
        flags = 0;
        valueID = 0;
        subValueID1 = 0;
        subValueID2 = 0;
    }
} VALUE_INFO;

typedef struct _NODES_DEPLOY_PATTERN {
#define MAX_NODES_PER_CELL          10000 
    int             pattern[MAX_NODES_PER_CELL * 2];
    int             numNodes;
    int             numCellPerAxis;
        
    _NODES_DEPLOY_PATTERN(void) {
        clear();
    }
    
    void clear() {
        memset(pattern, 0, (MAX_NODES_PER_CELL * 2) * sizeof(int));
        numCellPerAxis = 0;
        numNodes = 0;
    }
} NODES_DEPLOY_PATTERN;

typedef struct _GA_STRATEGY {
    GAS_ELEMENT_TYPE*   stratString;
    DWORD           stratStringSize;
    DWORD           secAmplifOffset;        // FIRST INSTRUCTION OF SECRECY AMPLIF PHASE WITHING STATEGY STRINg 

    VALUE_INFO*     valuesInfo;
    DWORD           valuesInfoSize;
    DWORD           newValue;

    SENSOR_NODE**   nodes;
    DWORD           nodesSize;
    
    float           fitness; 
    DWORD           totalKeys;
    
    DWORD           maxParties;
    DWORD           partyMemorySize;
    DWORD           maxInstruct;
    
    DWORD           numRepeat;
    BOOL            bAllEavesdropped;   // WHEN TRUE, ALL MESSAGES WITHIN PROTOCOL ARE EAVESDROPPED
    
    BOOL            prunneResults;
    BOOL            autoKeyDiscovery;
    BOOL            bAddDeploymentsFitnessTreshold; // ADD MORE DEPLOYMENTS TO EVAYULATION, WHEN GIVEN TRESHOLD REACHED
    int             moreDeploymentsCounter;         // NUMBER OF DEPLOYMENTS TO ADD
    float           moreDeploymentsTreshold;        // FITNESS TRESHOLD WHERE NEW DEPLOYMENTS ARE ADD
    int             fitnessStableGenersTreshold;    // TRESHOLD OF MAXIMUM GENERATIONS THAT CAN BE WITHOUT FITNESS IMPROVEMENTS, AFTER WHICH MESSAGE MINIMIZATION PHASE IS EXECUTED 
    
    BOOL            useSubFunct;
    int             sfncSlots;      // number of slots for subfunction call instruction
    int             sfncSize;       // maximum number of instructions, that can be inside one subfunction (~base offset)  
    int             sfncCount;      // number of subfunctions parts, that are present in main instruction pool (sfncCount == maxInstruct / sfncSize)
    
    // type of the protocol nature
    // FLAG_PROTOCOL_NODESORIENTED - protocol contains direct instructions for K nodes, all possible combinations of K nodes within group are used for protocol re-execution 
    // FLAG_PROTOCOL_GROUPORIENTED - protocol may contain different instructions for nodes based on its distance from the central node. Protocol is executed only once for group around given central node.   
    DWORD           protocolTypeFlags;  
    
    GAGenome*           pGenom;        
    GAGenome*           pBestGenom;        
    GASteadyStateGA*    pGA;
    float               pMutt;
    float               pCross;
    int                 popSize;
    int                 actGeneration;
    int                 generationOfMaxFit;
    int                 nGeners;
    int                 gLength;
    float               maxFit;         // global max. fitness
    float               maxFitGener;    // max. fitness for actual generation
    float               minimizeMsgFit; // fitness treshold, that must be reached during message minimization
    int                 totalMaxMsg;    // teoretical maximum of messages - is used to compute progress when minimizing number of messages     
    
    NODES_DEPLOY_PATTERN    blackDeployPattern;
    NODES_DEPLOY_PATTERN    whiteDeployPattern;
    _GA_STRATEGY(void) {
        clear();
    }
    
    void clear() {
        stratString = NULL;
        stratStringSize = 0;
        secAmplifOffset = 0;
        valuesInfo = NULL;
        valuesInfoSize = 0;
        newValue = 0;
        nodes = NULL;
        nodesSize = 0;
        fitness = 0;
        maxParties = 0;
        partyMemorySize = 0;
        maxInstruct = 0;
        numRepeat = 1;
        bAllEavesdropped = FALSE;
        prunneResults = FALSE;
        autoKeyDiscovery = FALSE;
        bAddDeploymentsFitnessTreshold = FALSE;
        moreDeploymentsCounter = 0;        
        moreDeploymentsTreshold = 0;  
        fitnessStableGenersTreshold = 1000;     
        useSubFunct = FALSE;
        sfncSlots = 0;
        sfncCount = 0;
        sfncSize = 0;
        totalKeys = 0;
        protocolTypeFlags = 0;
        pGenom = NULL; 
        pBestGenom = NULL;       
        pGA = NULL;
        pMutt = 0;
        pCross = 0;
        popSize = 0;
        actGeneration = 0;
        nGeners = 0;
        gLength = 0;
        maxFit = 0;
        maxFitGener = 0;
        minimizeMsgFit = 0;
        generationOfMaxFit = 0;
        blackDeployPattern.clear();
        whiteDeployPattern.clear();
    }
    
    void clearValuesInfo() {
        if (valuesInfo != NULL) memset(valuesInfo, 0, sizeof(VALUE_INFO) * valuesInfoSize);
        newValue = 0;
    }
     void clearNodes() {
        if (nodes != NULL) memset(nodes, 0, sizeof(SENSOR_NODE*) * nodesSize);
    }
    
    void release() {
        if (stratString != NULL) delete[] stratString;
        if (valuesInfo != NULL) delete[] valuesInfo;
        if (nodes != NULL) delete[] nodes;
        if (pGenom) {
            delete pGenom;
            pGenom = NULL;
        }       
        if (pGA) {
            delete pGA;
            pGA = NULL;
        }
        
        
        clear();
    }
    
    int convertRelativeToAbsolutID(GAS_ELEMENT_TYPE relativeID, CString* idString, DWORD protocolTypeFlags) {
        // RECOMPUTE FROM RELATIVE TO ABSOLUT IDENTIFICATION 
        
        // LOWEST 8bits OF relativeNodeIdentif IS RELATIVE DISTANCE FROM CENTRAL NODE pCentralNode
        // NEXT 8bits OF relativeNodeIdentif IS RELATIVE DISTANCE FROM ACTIVE NEIGHBOUR pNeighNode
        BYTE centralRelativeIdentif = (BYTE) (relativeID & 0xff);
        BYTE neighRelativeIdentif = (BYTE) ((relativeID & 0xff00) >> 8);

        if (protocolTypeFlags & FLAG_PROTOCOL_MUTUALRELATIVEDISTANCE) {
            if (centralRelativeIdentif < NODE_DIST_GRANULARITY && neighRelativeIdentif < NODE_DIST_GRANULARITY) {
                idString->Format("%.2f_%.2f", centralRelativeIdentif / (float) NODE_DIST_GRANULARITY, neighRelativeIdentif / (float) NODE_DIST_GRANULARITY);
            }
            else {
                if (relativeID % 2 == 1) *idString = "_1_"; // CENTRAL NODE
                else *idString = "_2_";                     // TARGET NEIGHBOUR
            }
        }
        else {
            if (centralRelativeIdentif < NODE_DIST_GRANULARITY) {
                idString->Format("%.2f", centralRelativeIdentif / (float) NODE_DIST_GRANULARITY);
            }
            else {
                if (relativeID % 2 == 1) *idString = "_1_"; // CENTRAL NODE
                else *idString = "_2_";                     // TARGET NEIGHBOUR
            }
        }
        return 0;
    }
    int toString(DWORD offset, CString* pMessage, DWORD protocolTypeFlags = FLAG_PROTOCOL_NODESORIENTED) {
        *pMessage = "";
        
        CString nodeString;
        if (protocolTypeFlags & FLAG_PROTOCOL_NODESORIENTED) nodeString.Format("%d", stratString[offset * GAS_INSLENGTH + GAS_OFFSET_NODE]);// ABSOLUT NODE ID ALREADY USED
        if (protocolTypeFlags & FLAG_PROTOCOL_GROUPORIENTED) convertRelativeToAbsolutID(stratString[offset * GAS_INSLENGTH + GAS_OFFSET_NODE], &nodeString, protocolTypeFlags);// RECOMPUTE FROM RELATIVE TO ABSOLUT IDENTIFICATION 

        switch (stratString[offset * GAS_INSLENGTH + GAS_OFFSET_INSTYPE]) {
            case GAS_INS_NOP: {
                pMessage->Format("NOP");
                break;
            }
            case GAS_INS_RNG: {
                pMessage->Format("RNG %d N%s Rt%d", stratString[offset * GAS_INSLENGTH + GAS_OFFSET_INSTAT], nodeString, stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM1]);
                break;
            }
            case GAS_INS_COMBINE: {
                pMessage->Format("CMB %d N%s Rv%d Rv%d Rt%d", stratString[offset * GAS_INSLENGTH + GAS_OFFSET_INSTAT], nodeString, stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM1], stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM2], stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM3]);
                break;
            }
            case GAS_INS_REMOTECOMBINE: {
                CString secondNodeString;
                if (protocolTypeFlags & FLAG_PROTOCOL_NODESORIENTED) secondNodeString.Format("%d", stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM1]);// ABSOLUT NODE ID ALREADY USED
                if (protocolTypeFlags & FLAG_PROTOCOL_GROUPORIENTED) convertRelativeToAbsolutID(stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM1], &secondNodeString, protocolTypeFlags); // RECOMPUTE FROM RELATIVE TO ABSOLUT IDENTIFICATION 
                
                pMessage->Format("RCB %d N%s N%s Rv%d Rt%d", stratString[offset * GAS_INSLENGTH + GAS_OFFSET_INSTAT], nodeString, secondNodeString, stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM2], stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM3]);
                break;
            }
            case GAS_INS_SEND: {
                CString secondNodeString;
                if (protocolTypeFlags & FLAG_PROTOCOL_NODESORIENTED) secondNodeString.Format("%d", stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM1]);// ABSOLUT NODE ID ALREADY USED
                if (protocolTypeFlags & FLAG_PROTOCOL_GROUPORIENTED) convertRelativeToAbsolutID(stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM1], &secondNodeString, protocolTypeFlags); // RECOMPUTE FROM RELATIVE TO ABSOLUT IDENTIFICATION 

                pMessage->Format("SND %d N%s N%s Rv%d Rt%d", stratString[offset * GAS_INSLENGTH + GAS_OFFSET_INSTAT], nodeString, secondNodeString, stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM2], stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM3]);
                break;
            }
            case GAS_INS_ENCRYPT: {
                pMessage->Format("ENC %d N%s Rv%d Rk%d Rt%d", stratString[offset * GAS_INSLENGTH + GAS_OFFSET_INSTAT], nodeString, stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM1], stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM2], stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM3]);
                break;
            }
            case GAS_INS_DECRYPT: {
                pMessage->Format("DEC %d N%s Rv%d Rk%d Rt%d", stratString[offset * GAS_INSLENGTH + GAS_OFFSET_INSTAT], nodeString, stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM1], stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM2], stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM3]);
                break;
            }
            case GAS_INS_SWITCH: {
                pMessage->Format("SWC %d", stratString[offset * GAS_INSLENGTH + GAS_OFFSET_INSTAT]);
                break;
            }
            case GAS_INS_SUBFUNCTCALL: {
                pMessage->Format("FNC %d f%d i%d", stratString[offset * GAS_INSLENGTH + GAS_OFFSET_INSTAT], stratString[offset * GAS_INSLENGTH + GAS_OFFSET_NODE], stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM1]);
                break;
            }
            default: {
                pMessage->Format("UNKNOWN '%d' %d N%s Rv%d Rk%d Rt%d", stratString[offset * GAS_INSLENGTH + GAS_OFFSET_INSTYPE], stratString[offset * GAS_INSLENGTH + GAS_OFFSET_INSTAT], nodeString, stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM1], stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM2], stratString[offset * GAS_INSLENGTH + GAS_OFFSET_PARAM3]);
                break;
            }
        }
        return 0;
    }
    
    int settingsToString(CString* pMessage) {
        CString value;
        // FORMAT SETTINGS STRING
        value.Format("maxParties=%d#\r\n", maxParties);
        *pMessage += value;
        value.Format("partyMemorySize=%d#\r\n", partyMemorySize);
        *pMessage += value;
        value.Format("maxInstructs=%d#\r\n", maxInstruct);
        *pMessage += value;
        value.Format("numRepeat=%d#\r\n", numRepeat);
        *pMessage += value;
        value.Format("prunneResults=%d#\r\n", prunneResults);
        *pMessage += value;
        value.Format("useSubFunct=%d#\r\n", useSubFunct);
        *pMessage += value;
        value.Format("sfncSlots=%d#\r\n", sfncSlots);
        *pMessage += value;
        value.Format("sfncSize=%d#\r\n", sfncSize);
        *pMessage += value;
        value.Format("sfncCount=%d#\r\n", sfncCount);
        *pMessage += value;
        value.Format("pMutt=%.3f#\r\n", pMutt);
        *pMessage += value;
        value.Format("pCross=%.3f#\r\n", pCross);
        *pMessage += value;
        value.Format("popSize=%d#\r\n", popSize);
        *pMessage += value;
        value.Format("nGeners=%d#\r\n", nGeners);
        *pMessage += value;
        value.Format("gLength=%d#\r\n", gLength);
        *pMessage += value;
        return 0;
    }
    
    int parseSettingsFromString(CString message) {
        maxParties = (int) parseValueFromString("maxParties=", message);
        partyMemorySize = (int) parseValueFromString("partyMemorySize=", message);
        maxInstruct = (int) parseValueFromString("maxInstructs=", message);
        numRepeat = (int) parseValueFromString("numRepeat=", message);
        prunneResults = (int) parseValueFromString("prunneResults=", message);
        useSubFunct = (int) parseValueFromString("useSubFunct=", message);
        sfncSlots = (int) parseValueFromString("sfncSlots=", message);
        sfncSize = (int) parseValueFromString("sfncSize=", message);
        sfncCount = (int) parseValueFromString("sfncCount=", message);
        pMutt = parseValueFromString("pMutt=", message);
        pCross = parseValueFromString("pCross=", message);
        popSize = (int) parseValueFromString("popSize=", message);
        nGeners = (int) parseValueFromString("nGeners=", message);
        gLength = (int) parseValueFromString("gLength=", message);
        
        return 0;
    }
    
    float parseValueFromString(CString key, CString settings) {
        CString value;
        int     pos = 0;
        int     pos2 = 0;
        float   ret = -1;
        
        if ((pos = settings.Find(key)) != -1) {
            if ((pos2 = settings.Find("#", pos)) != -1) {
                value = settings.Mid(pos + key.GetLength(), pos2 - pos - key.GetLength());
                value.TrimLeft();value.TrimRight();
                ret = (float) atof(value);
            }
        }
        
        return ret;
    }
} GA_STRATEGY;

typedef struct _DEPLOYMENT_INFO {
    GEO_GRID            geoGrid;           // 2D geographic grid with pointers to sensor node structure for fast query like: "Which sensors covers [x, y] position?"
    SENSOR_LIST         whiteSensorList;   // array of all allocated sensor nodes for fast node retriaval by its ID and neighbour list 
    SENSOR_LIST         blackSensorList;   // array of all allocated sensor nodes for fast node retriaval by its ID and neighbour list 
    BASE_STATIONS_LIST  BSList;            // list of base stations nodes
	BOOL                sensorsDeployed;   // deloyment was performed 

    _DEPLOYMENT_INFO() {
        clear();
    }
    
    void clear() {
        sensorsDeployed = FALSE;
    }

	void release() {
		clear();
		geoGrid.release();
		whiteSensorList.release();
		blackSensorList.release();
		BSList.release();
	}

} DEPLOYMENT_INFO;
 
 
 
typedef struct _REMOTE_HOST_INFO {
	CString		IP;
	CString		status;
	CString		actResult;
	CString		identif;
	CString		date;
	
	_REMOTE_HOST_INFO(void) {
		clear();
	}
	
	void clear() {
		IP = "";
		status = "";
		actResult = "";
		identif = "";
		date = "";
	}
} REMOTE_HOST_INFO;


// GA CIRCUIT CONSTANTS
#define NUM_BITS                    8             // NUMBER OF BITS PER BYTE
#define NUM_TEST_SETS               1000
#define MAX_TEST_SET_SIZE_PER_GENOM 1000   
#define TEST_SET_SIZE               MAX_TEST_SET_SIZE_PER_GENOM * NUM_TEST_SETS

#define PREDICT_BIT                 0
#define PREDICT_BITGROUP_PARITY     1
#define PREDICT_BYTES_PARITY        2
#define PREDICT_HAMMING_WEIGHT      3

#define TESTVECT_MD5INV             0
#define TESTVECT_SHA1INV            1
#define TESTVECT_DESPLAINTEXT       2
#define TESTVECT_TEST               3
#define TESTVECT_MD5SHA_DISTINGUISH		4
#define TESTVECT_MD5_RAND_DISTINGUISH   5
#define TESTVECT_SHA1_RAND_DISTINGUISH  6

#define FNC_NOP                     0
#define FNC_OR                      1
#define FNC_AND                     2
#define FNC_CONST                   3
#define FNC_XOR                     4
#define FNC_NOR                     5
#define FNC_NAND                    6
#define FNC_ROTL                    7
#define FNC_ROTR                    8
#define FNC_BITSELECTOR             9
#define FNC_SUM                     10
#define FNC_SUBS                    11
#define FNC_ADD                     12
#define FNC_MULT                    13
#define FNC_DIV                     14
#define FNC_MAX                     FNC_DIV + 1

#define MAX_NUM_LAYERS              100
#define MAX_CONNECTORS              32
#define MAX_INTERNAL_LAYER_SIZE     32
#define MAX_OUTPUTS                 MAX_INTERNAL_LAYER_SIZE  
#define MAX_INPUTS                  MAX_INTERNAL_LAYER_SIZE * MAX_INTERNAL_LAYER_SIZE // IF bSectorData IS ENABLED, SEPARATE RANGE FOR EACH INPUT NODE IN FIRST LAYER IS USED  
#define MAX_GENOME_SIZE (MAX_NUM_LAYERS * 2) * MAX_INTERNAL_LAYER_SIZE

typedef struct _GA_CIRCUIT {
    // BASIC CIRCUIT PARAMS
    int         numLayers;  
    int         numSelectorLayers;
    int         numInputs;
    int         numOutputs;
    int         internalLayerSize;
    int         outputLayerSize;
    int         numLayerConnectors;
    BOOL        bSectorInputData;
    BYTE        allowedFNC[FNC_MAX];
    int         predictMethod;
	// TESTING VECTORS PARAMETERS
    int         numTestVectors;
    BYTE**      testVectors;
    int         testVectStart; // offset where testing set is taking from  
    int         testVectorGenerMethod;
    int         testVectorChangeGener;  // generate fresh new test set every x-th generation
    BOOL        bSplitTestVectors;
    int         numBestPredictors;
	BOOL		limitAlgRounds;
	int			limitAlgRoundsCount;
	BOOL		representBitAsBytes;
	// SPEED-UP PRECOMPUTATION 
    DWORD       precompPow[MAX_CONNECTORS];      // PRECOMPUTED VALUES UP TO 2^32
    DWORD       powEffectiveMask;
	// PARAMETERS OF GENOM FOR THIS CIRCUIT	
	int         genomeSize;
    // INFO ABOUT FITNESS
    float     maxFit;
    float     bestGenerFit;
    float     avgGenerFit;
    int       numAvgGenerFit;
    int       avgPredictions;
    
    BOOL      prunningInProgress;

    _GA_CIRCUIT(void) {
        numLayers = MAX_NUM_LAYERS;
        numSelectorLayers = 1;
        numInputs = MAX_INTERNAL_LAYER_SIZE;
        numOutputs = MAX_INTERNAL_LAYER_SIZE;
        internalLayerSize = MAX_INTERNAL_LAYER_SIZE;
        outputLayerSize = MAX_OUTPUTS;
        bSectorInputData = FALSE;
        predictMethod = 0;
        memset(allowedFNC, 1, sizeof(allowedFNC)); // allow all functions by default
        
        numTestVectors = 100;
        testVectors = NULL;
        testVectStart = 0; 
        testVectorGenerMethod = 0;
        testVectorChangeGener = 0;
        bSplitTestVectors = FALSE;
        numBestPredictors = 1;
		limitAlgRounds = FALSE;
		limitAlgRoundsCount = -1;
		representBitAsBytes = FALSE;

        genomeSize = MAX_GENOME_SIZE;
        
        maxFit = 0;
        bestGenerFit = 0;
        avgGenerFit = 0;
        numAvgGenerFit = 0;
        avgPredictions = 0;
        
        // PRECOMPUTE POW FUNCTION FOR REASONABLE VALUES
        for (int bit = 0; bit < MAX_CONNECTORS; bit++) {
            precompPow[bit] = (DWORD) pow(2, (float) bit);
            powEffectiveMask |= precompPow[bit];
        }
        
        prunningInProgress = FALSE;
    } 
    
    void allocate() {
        if (testVectors != NULL) release();
        testVectors = new BYTE*[numTestVectors];
        for (int i = 0; i < numTestVectors; i++) testVectors[i] = new BYTE[MAX_INPUTS + MAX_OUTPUTS];
    }
    
    void clearFitnessStats() {
        maxFit = 0;
        bestGenerFit = 0;
        avgGenerFit = 0;
        numAvgGenerFit = 0;
        avgPredictions = 0;
    }
    
    void release() {
        if (testVectors != NULL) {
            for (int i = 0; i < numTestVectors; i++) delete[] testVectors[i];
            delete[] testVectors;
            testVectors = NULL;
        }
   }
} GA_CIRCUIT;

typedef struct _BASIC_INIT_DATA {
    CString simulSWVersion;
    CString simulDate;
    // WHITE SENSORS
    DWORD   whiteNum;
    int     undeployedWhiteNum;     // number of nodes, that are prepared but not deployed yet 
    float   whiteTransmRange;   
    float   whiteRatioReceiveRange; // RECEIVE SENSITIVITY RATIO ACCORDING TO WHITE TRANSMISSION RANGE    
    float   whiteFailureRate;       // <0, 1> 0...no one will fail, 1...all will fail  
    
    DWORD   useOnlyXNeigh;          // if non-zero, then number of neighbours used during key distributions are limited to this number
    DWORD   useNeighFlags;      
    
    DWORD   distribFlags;           // flags relevant to key distribution part of simulation
    float   distribKeysCompr;       // percentage of keys which are marked randomly as compromised (when distribution phase is omitted)    
	float   removeMostComprBlack;	// percentage of most compromissing black nodes which will be omitted from next results 	
    float   blackRatioWhite;        // ratio of black to white sensor nodes count

    // BLACK SENSORS
    DWORD   blackNum;
    float   blackTransmRange;
    float   blackRatioReceiveRange; // RECEIVE SENSITIVITY RATIO ACCORDING TO WHITE TRANSMISSION RANGE    
    BYTE    blackCountType;    

    // TARGET PLANE PARAMS
    BYTE    planeType;
    float   planeX;                 // [0, 0] is left upper corner; [planeX, 0] is right upper corner; 
    float   planeY;                 // [planeX, planeY] is right botom corner; 
    float   planeRadius;

    // TEST SETTINGS
	BOOL	plainMaxScream;
	BOOL	basicWhisper;
	BOOL	mutualWhisper;
    BOOL    rossAmplifWhisper;
	BOOL	danAmplifWhisper;
	BOOL	rossAmplifMutualWhisper;
	BOOL	danAmplifMutualWhisper;

    BOOL    maintainCompromissedBy;     // if TRUE, than list of black node which have compromissed this given link key is maintained
	
    BYTE	amplifRepeat;
	BYTE	numDeployments;				// number of deployments deployed at the same time
    DWORD   testType;                   // type of test, which is going to be performed
    
    // BATCH RUN TEST SETTINGS
    BATCH_TEST_SETTINGS batchTest;

    // EG SCHEME DATA
    EG_SCHEME       egScheme;

    // FORWARD ONION ENCRYPTION
    FOE_CONFIG      foeConfig;

    // BASE STATIONS SETTINGS
    BASE_STATIONS   bsConfig;

	// MULTI-PATH MESSAGE DELIVERY CONFIG
	MMD_CONFIG	    mmdConfig;

    // RANDOM SEED VALUE
    RANDOM_GENERATOR    rndGen;

    // NEIGHBOUR LEASHES SETTINGS
    NEIGHLEASH_CONFIG   neighLeash;

	// REMOTRE CONTROL SETTINGS
	REMOTE_CTRL_CONFIG	remoteConfig;

	// SETTINGS FOR EVOLUTIONARY ALGORITHMS
	GA_STRATEGY			gaConfig;

	// SETTINGS FOR EVOLUTIONARY CIRCUIT
	GA_CIRCUIT			gaCircuitConfig;

    _BASIC_INIT_DATA(void) {
        clear();
    }

    void clear() {
        simulSWVersion = "";
        simulDate = "";

        whiteNum = 0;
        undeployedWhiteNum = 0;
        whiteTransmRange = 0;
        whiteRatioReceiveRange = 1;
        whiteFailureRate = 0;
        
        useOnlyXNeigh = 0;
        useNeighFlags = 0;

        distribFlags = 0;      
        distribKeysCompr = 0;  

        blackNum = 0;
        blackTransmRange = 0;
        blackRatioReceiveRange = 1;   
        blackCountType = 0;
        blackRatioWhite = 1;

        planeType = 0;
        planeX = 0;
        planeY = 0;
        planeRadius = 0;

        plainMaxScream = 0;
        basicWhisper = 0;
        mutualWhisper = 0;
        rossAmplifWhisper = 0;
        danAmplifWhisper = 0;
        rossAmplifMutualWhisper = 0;
        danAmplifMutualWhisper = 0;

        maintainCompromissedBy = FALSE;

        amplifRepeat = 0;
		numDeployments = 1;
        testType = 0;
        
        batchTest.clear();
        egScheme.clear();
        foeConfig.clear();
        bsConfig.clear();
        mmdConfig.clear();
        rndGen.clear();
		remoteConfig.clear();
		gaConfig.clear();
    }

} BASIC_INIT_DATA;

typedef struct _GACIRCUIT_THREAD_PARAM {
    BASIC_INIT_DATA     basicSettings;
    GA_STRATEGY         gaStrategy;
    void*               pGACircuit;
    int                 limitTestVectorAlgRounds;

    _GACIRCUIT_THREAD_PARAM(void) {
        basicSettings.clear();
        gaStrategy.clear();
        pGACircuit = NULL;
        limitTestVectorAlgRounds = 0;
    }
} GACIRCUIT_THREAD_PARAM;

typedef struct _TEST_THREAD_PARAM {
    BASIC_INIT_DATA     basicSettings;
    void*               pTestQueue;
    BOOL                bExitApp;

    _TEST_THREAD_PARAM(void) {
        basicSettings.clear();
        pTestQueue = NULL;
        bExitApp = FALSE;
    }
} TEST_THREAD_PARAM;

typedef struct _GABP_THREAD_PARAM {
    GA_STRATEGY*        pGAStrategy;
	BOOL				bBlackPattern;

    _GABP_THREAD_PARAM(void) {
		pGAStrategy = NULL;
		bBlackPattern = TRUE;
    }
} GABP_THREAD_PARAM;

typedef struct _GRAPH_DATA {
    BOOL    redrawGraph;        // IF FALSE, THEN GRAPH IS NOT REDRAWED             
	float	resizeRatio;
	int		global_horizontal;
	CString capturePath;
    BOOL    captureScreen;
    
    _GRAPH_DATA(void) {
        clear();    
    }

    void clear() {
        redrawGraph = TRUE;
        capturePath = "";
        captureScreen = FALSE;
		resizeRatio = (float) 1;
		global_horizontal = 0;
    }
} GRAPH_DATA;

//JK
typedef struct _GAROUTE_THREAD_PARAM {
	BASIC_INIT_DATA     basicSettings;
	GA_STRATEGY         gaStrategy;
	void*               pGARoute;

	_GAROUTE_THREAD_PARAM(void) {
		basicSettings.clear();
		gaStrategy.clear();
		pGARoute=NULL;

	}
} GAROUTE_THREAD_PARAM;


#endif