// SensorSimDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SensorSim.h"
#include "SensorSimDlg.h"
#include "VersionInfo.h"
#include "CommonFnc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CSensorSimDlg*     pSensorSim = NULL;
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSensorSimDlg dialog

CSensorSimDlg::CSensorSimDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSensorSimDlg::IDD, pParent)
    , m_hostPC(_T(""))
{
	//{{AFX_DATA_INIT(CSensorSimDlg)
	m_logs = _T("");
	m_keepLogBelow = TRUE;
	m_maxLogSize = _T("1000000");
	m_bStopThread = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

    pSensorSim = this;

    pSensorSim->m_pActualThread = NULL;
    m_stopThreadSoft = FALSE;
    
    
    //
    //  ALLOCATE STRATEGY RESOURCES
    //
    //m_pGAStrategy = new GA_STRATEGY;
	m_pGAStrategy = &(pSensorSim->m_sensorEnv.m_basicSettings.gaConfig);
    CSensorEnv::GAS_AllocateDefaultStrategyStructs(m_pGAStrategy);
    CSensorEnv::GAS_AllocateDefaultStrategyStructs(&m_tempStrategy);

     // STARTUP PATH
    GetCurrentDirectory(MAX_PATH, m_basePath.GetBuffer(MAX_PATH));
    m_basePath.ReleaseBuffer();
    
    m_pSocketServer = NULL;
	m_pProxyThread = NULL;
	
    m_pEACircuit = NULL;
	m_pEACircuit = new CEACircuit();
}

CSensorSimDlg::~CSensorSimDlg() {
    pSensorSim->m_sensorEnv.Release();
/* this pointer is freed during pSensorSim->m_sensorEnv.Release();
	if (pSensorSim->m_pGAStrategy != NULL) {
        pSensorSim->m_pGAStrategy->release();
        delete pSensorSim->m_pGAStrategy;
    }
/**/
	pSensorSim->m_tempStrategy.release();

    pSensorSim->m_bStopThread = TRUE; 
	if (m_pProxyThread) {
		TerminateThread(m_pProxyThread, 0);
		m_pProxyThread = NULL;
	}

	if (m_pSocketServer != NULL) {
		delete m_pSocketServer;
		m_pSocketServer = NULL;
	}
	
	if (m_pEACircuit != NULL) {
		m_pEACircuit->m_gaCirc.release();
		delete m_pEACircuit;
		m_pEACircuit = NULL;
	}
}

void CSensorSimDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CSensorSimDlg)
    DDX_Control(pDX, IDC_MAINTAB, m_mainTab);
    DDX_Text(pDX, IDC_LOGS, m_logs);
    DDX_Check(pDX, IDC_KEEP_LOG_BELOW, m_keepLogBelow);
    DDX_Text(pDX, IDC_MAX_LOG_SIZE, m_maxLogSize);
    //}}AFX_DATA_MAP
    DDX_CBString(pDX, IDC_COMBO_HOSTPC, m_hostPC);
}

BEGIN_MESSAGE_MAP(CSensorSimDlg, CDialog)
	//{{AFX_MSG_MAP(CSensorSimDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(TCN_SELCHANGE, IDC_MAINTAB, OnSelchangeMaintab)
    ON_MESSAGE(WM_LOG_INSERTSTRING, OnLogInsertString)
    ON_MESSAGE(WM_RNG_UPDATESEED, OnUpdateRNGSeed)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
    ON_EN_CHANGE(IDC_LOGS, &CSensorSimDlg::OnEnChangeLogs)
    ON_BN_CLICKED(IDC_STOP_CURRENT_OPERATIONS, &CSensorSimDlg::OnBnClickedStopCurrentOperations)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSensorSimDlg message handlers

BOOL CSensorSimDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	

	RECT rect;

	m_mainTab.InsertItem(ID_BASIC_TAB, STR_BASIC_TAB);
	m_mainTab.InsertItem(ID_KEYESTABLISH_TAB, STR_KEYESTABLISH_TAB);
	m_mainTab.InsertItem(ID_KEYINFECT_TAB, STR_KEYINFECT_TAB);
	m_mainTab.InsertItem(ID_KEYPREDISTRIB_TAB, STR_KEYPREDISTRIB_TAB);
	m_mainTab.InsertItem(ID_BSROUTE_TAB, STR_BSROUTE_TAB);
	m_mainTab.InsertItem(ID_MESH_TAB, STR_MESH_TAB);
	m_mainTab.InsertItem(ID_NEIGHLEASH_TAB, STR_NEIGHLEASH_TAB);
	m_mainTab.InsertItem(ID_REMOTECONTROL_TAB, STR_REMOTECONTROL_TAB);
	m_mainTab.InsertItem(ID_GRAPHIC_TAB, STR_GRAPHIC_TAB);

	m_mainTab.GetClientRect( &rect );
	m_mainTab.AdjustRect( FALSE, &rect );

	m_tabBasic.Create(IDD_BASIC_TAB, &m_mainTab);
	m_tabBasic.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabKeyEstablish.Create(IDD_KEYESTABLISH_TAB, &m_mainTab);
	m_tabKeyEstablish.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabKeyInfect.Create(IDD_KEYINFECT_TAB, &m_mainTab);
	m_tabKeyInfect.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabKeyPredistrib.Create(IDD_PREDISTRIB_TAB, &m_mainTab);
	m_tabKeyPredistrib.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabBSRoute.Create(IDD_BSROUTE_TAB, &m_mainTab);
	m_tabBSRoute.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabMesh.Create(IDD_MESH_TAB, &m_mainTab);
	m_tabMesh.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabNeighLeash.Create(IDD_NEIGHLEASHES_TAB, &m_mainTab);
	m_tabNeighLeash.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabRemoteControl.Create(IDD_REMOTE_CONTROL_TAB, &m_mainTab);
	m_tabRemoteControl.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabGraphic.Create(IDD_GRAPHIC_TAB, &m_mainTab);
	m_tabGraphic.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );
    
    ShowSpecificTab(ID_MESH_TAB);

    // INIT RANDOM GENERATOR
    DWORD seed = (unsigned int) time(NULL);
    m_sensorEnv.m_rndGen.InitRandomGenerator(seed);

    // UPDATE SEED VALUE IN BasicTab
    m_tabBasic.UpdateData(TRUE);
    m_tabBasic.m_randomSeed.Format("%u", seed);
    m_tabBasic.UpdateData(FALSE);

    //
    // DISPLAY COMMAND LINE HELP
    //
    CString message;
    CVersionInfo    ver;    
    ver.GetVersionInfo("SensorSim.exe");

    message.Format("S3 - Sensor Security Simulator, version %s\n", ver.m_strFixedProductVersion);
    LOG_INSERTSTRING_NOTIME(message, FALSE);

    message.Format("*****************************************************************************************\n\
COMMAND LINE SWITCHES\n \
  /s:\"filepath.ini\" ... configuration script to be loaded (do not ommit \"\")\n \
  /r                      ... run test required by configuration script (/s: switch)\n\
   /e                     ... exit application after executed tests\n\
   /x:\"port\"          ... run remote control proxy (e.g., port 4001)\n\
*****************************************************************************************");
    LOG_INSERTSTRING_NOTIME(message, FALSE);

    //
    // OBTAIN AND PARSE COMMAND LINE PARAMETERS
    //
    CString tempCmdLine;
    CString path;
    int     status = STAT_OK;
    int     pos;
    int     pos2;
    tempCmdLine = GetCommandLine();
    tempCmdLine.TrimRight();
    tempCmdLine += " ";
    BASIC_INIT_DATA*    pBasicSettings = NULL;


    // EXTERNAL CONFIGURATION SCRIPT
    if ((pos = tempCmdLine.Find("/s:\"")) != -1) {
        pos += (int) strlen("/s:\""); 
        pos2 = tempCmdLine.Find("\"", pos);
        path = tempCmdLine.Mid(pos, pos2 - pos);

        pBasicSettings = new BASIC_INIT_DATA;
        // LOAD SUPPLIED CONFIGURATION SCRIPT
        if ((status = pSensorSim->m_sensorEnv.LoadConfigScript(path, pBasicSettings)) == STAT_OK) {
            status = pSensorSim->SetBasicSettings(pBasicSettings);
        }
        if (status != STAT_OK) {
            message.Format("Load config. script '%s' fail with %s(%d)", path, ErrorToString(status), status);
            LOG_INSERTSTRING(message);
        } 
        else {
            message.Format("Load config. script '%s' OK", path);
            LOG_INSERTSTRING(message);

        }
    }
	else {
		BASIC_INIT_DATA		basicSettings;			
		// USE INTERNAL SCRIPT
		m_defaultCfgFile.Format("%s\\default_cfg.ini", pSensorSim->m_basePath);
        // LOAD SUPPLIED CONFIGURATION SCRIPT
        if ((status = pSensorSim->m_sensorEnv.LoadConfigScript(m_defaultCfgFile, &basicSettings)) == STAT_OK) {
            status = pSensorSim->SetBasicSettings(&basicSettings);
        }
	}

    // EXIT AFTER TESTS IF REQUIRED
    if ((pos = tempCmdLine.Find("/e ")) != -1) {
        pSensorSim->m_tabKeyEstablish.TestQueue_ExitAfterTests(TRUE);
    }

    // RUN REQUIRED TESTS
    if ((pos = tempCmdLine.Find("/r ")) != -1) {
        if (pBasicSettings != NULL) {
            pSensorSim->m_tabKeyEstablish.TestQueue_Add(pBasicSettings);
            pSensorSim->m_tabKeyEstablish.TestQueue_Run();
        }
    }

    // RUN IN PROXY MODE
    if ((pos = tempCmdLine.Find("/x:\"")) != -1) {
        pos += (int) strlen("/x:\""); 
        pos2 = tempCmdLine.Find("\"", pos);
        int port = atoi(tempCmdLine.Mid(pos, pos2 - pos));
        // OPEN PROXY ON GIVEN PORT AND LISTEN FOR COMMANDS
        
        RunProxy(port);
    }

    m_logFile = "s3.log";
    CFile   file;
    if (file.Open(pSensorSim->m_logFile, CFile::modeWrite | CFile::modeCreate | CFile::modeNoTruncate)) {
        file.SeekToEnd();
        file.Write("**********", (int) strlen("**********"));    
        file.Close();
    }
    
    // SET CAPTION WITH PATH INSIDE FOR EASIER MANAGEMNT OF MULTIPLE RUNNING INSTANCES 
    CString caption;
    CString newCaption;
    this->GetWindowText(caption.GetBuffer(MAX_PATH), MAX_PATH);
    caption.ReleaseBuffer();
    newCaption.Format("%s [%s]", caption, m_basePath);
    this->SetWindowText(newCaption);
    
    // DECRERASE PRIORITY OF THIS PROCESS
    SetPriorityClass(GetCurrentProcess(), IDLE_PRIORITY_CLASS);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSensorSimDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSensorSimDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSensorSimDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSensorSimDlg::HideAllTabs() {
	m_tabBasic.ShowWindow(SW_HIDE);
	m_tabKeyEstablish.ShowWindow(SW_HIDE);
	m_tabKeyInfect.ShowWindow(SW_HIDE);
    m_tabKeyPredistrib.ShowWindow(SW_HIDE);
    m_tabMesh.ShowWindow(SW_HIDE);
    m_tabBSRoute.ShowWindow(SW_HIDE);
    m_tabNeighLeash.ShowWindow(SW_HIDE);
	m_tabRemoteControl.ShowWindow(SW_HIDE);
	m_tabGraphic.ShowWindow(SW_HIDE);
}

void CSensorSimDlg::ShowBasicTab() {
	HideAllTabs();
	m_tabBasic.ShowWindow(SW_SHOWNORMAL);
}

void CSensorSimDlg::ShowKeyEstablishTab() {
	HideAllTabs();
	m_tabKeyEstablish.ShowWindow(SW_SHOWNORMAL);
}

void CSensorSimDlg::ShowKeyInfectTab() {
	HideAllTabs();
	m_tabKeyInfect.ShowWindow(SW_SHOWNORMAL);
}

void CSensorSimDlg::ShowKeyPredistribTab() {
	HideAllTabs();
	m_tabKeyPredistrib.ShowWindow(SW_SHOWNORMAL);
}

void CSensorSimDlg::ShowBSRouteTab() {
	HideAllTabs();
	m_tabBSRoute.ShowWindow(SW_SHOWNORMAL);
}
void ShowBSRouteTab();

void CSensorSimDlg::ShowMeshTab() {
	HideAllTabs();
	m_tabMesh.ShowWindow(SW_SHOWNORMAL);
}

void CSensorSimDlg::ShowNeighLeashTab() {
	HideAllTabs();
	m_tabNeighLeash.ShowWindow(SW_SHOWNORMAL);
}


void CSensorSimDlg::ShowRemoteControlTab() {
	HideAllTabs();
	m_tabRemoteControl.ShowWindow(SW_SHOWNORMAL);
}

void CSensorSimDlg::ShowGraphicTab() {
	HideAllTabs();
	m_tabGraphic.ShowWindow(SW_SHOWNORMAL);
}

void CSensorSimDlg::ShowSpecificTab(int tabID) {
	switch (tabID) {
		case ID_BASIC_TAB: {
	        m_mainTab.SetCurSel(ID_BASIC_TAB);
			ShowBasicTab();
			break;
		}
		case ID_KEYESTABLISH_TAB: {
	        m_mainTab.SetCurSel(ID_KEYESTABLISH_TAB);
			ShowKeyEstablishTab();
			break;
		}
		case ID_KEYINFECT_TAB: {
	        m_mainTab.SetCurSel(ID_KEYINFECT_TAB);
			ShowKeyInfectTab();
			break;
		}
		case ID_KEYPREDISTRIB_TAB: {
	        m_mainTab.SetCurSel(ID_KEYPREDISTRIB_TAB);
			ShowKeyPredistribTab();
			break;
		}
		case ID_BSROUTE_TAB: {
	        m_mainTab.SetCurSel(ID_BSROUTE_TAB);
			ShowBSRouteTab();
			break;
		}
		case ID_MESH_TAB: {
	        m_mainTab.SetCurSel(ID_MESH_TAB);
			ShowMeshTab();
			break;
		}
		case ID_NEIGHLEASH_TAB: {
	        m_mainTab.SetCurSel(ID_NEIGHLEASH_TAB);
			ShowNeighLeashTab();
			break;
		}
		case ID_REMOTECONTROL_TAB: {
	        m_mainTab.SetCurSel(ID_REMOTECONTROL_TAB);
			ShowRemoteControlTab();
			break;
		}
		case ID_GRAPHIC_TAB: {
			m_mainTab.SetCurSel(ID_GRAPHIC_TAB);
			ShowGraphicTab();
			break;
		}
		default: {
	        m_mainTab.SetCurSel(ID_BASIC_TAB);
			ShowBasicTab();
			break;
		}
	}	
}


void CSensorSimDlg::OnSelchangeMaintab(NMHDR* pNMHDR, LRESULT* pResult) 
{
    int sel = m_mainTab.GetCurSel();
    ShowSpecificTab(sel);
	
	*pResult = 0;
}

int CSensorSimDlg::Log_InsertString(CString message, BOOL bShowTime, BOOL bToFile) {
    int             status = STAT_OK;
    char            timeStr[MAX_PATH];

    UpdateData(TRUE);

    message.Replace("\n", "\r\n");

    // TIME STAMP
    if (bShowTime) {
        message.Insert(0, "  ");
        _strtime(timeStr);
        message.Insert(0, timeStr); 
    }
    
    // ADD ENDING "\r\n" IF NOT ALREADY PRESENT
    if (message.Right(2) != "\r\n") message += "\r\n";
    
    // ADD ENDING "\r\n" TO EXISTING LOG MESSAGE IF NOT ALREADY PRESENT
    if (m_logs.Right(2) != "\r\n") m_logs += "\r\n";
    m_logs += message;
    // TRIM LOG IF REQUIRED
    if (m_keepLogBelow) m_logs = m_logs.Right(atoi(m_maxLogSize));
/**/
    // WRITE INTO LOG FILE 
    if (bToFile) Log_InsertToFile(pSensorSim->m_logFile, message);

    UpdateData(FALSE);
    Log_EnsureVisibleLastLine();

    return status;
}

int CSensorSimDlg::Log_AppendString(CString message) {
    int             status = STAT_OK;

    UpdateData(TRUE);

    message.Replace("\n", "\r\n");

    m_logs += message;

    // TRIM LOG IF REQUIRED
    if (m_keepLogBelow) m_logs = m_logs.Right(atoi(m_maxLogSize));

    // WRITE INTO LOG FILE 

    UpdateData(FALSE);

    Log_EnsureVisibleLastLine();
    
    return status;
}

int CSensorSimDlg::Log_InsertClearLine() {
    int             status = STAT_OK;
    UpdateData(TRUE);

    m_logs += "\r\n"; 

    // TRIM LOG IF REQUIRED
    if (m_keepLogBelow) m_logs = m_logs.Right(atoi(m_maxLogSize));

    // WRITE INTO LOG FILE 
    //TODO: CCommonFnc::File_AppendString(pSensorSim->m_logFile, "\n");

    UpdateData(FALSE);

    Log_EnsureVisibleLastLine();

    return status;
}

int CSensorSimDlg::Log_InsertSeparator() {
    int             status = STAT_OK;
    UpdateData(TRUE);

    m_logs += "==================================================================\r\n"; 

    // TRIM LOG IF REQUIRED
    if (m_keepLogBelow) m_logs = m_logs.Right(atoi(m_maxLogSize));

    // WRITE INTO LOG FILE 
    //TODO: CCommonFnc::File_AppendString(pSensorSim->m_logFile, "==================================================================\r\n");

    UpdateData(FALSE);
    
    Log_EnsureVisibleLastLine();

    return status;
}

int CSensorSimDlg::Log_EnsureVisibleLastLine() {
    int     status = STAT_OK;
    
    CEdit* pEdit;
    if ((pEdit = (CEdit*) GetDlgItem(IDC_LOGS)) != NULL) {
        pEdit->LineScroll(pEdit->GetLineCount());
/*
        int nFirstVisible = pEdit->GetFirstVisibleLine();

        // Scroll the edit control so that the first visible line
        // is the first line of text.
        if (nFirstVisible > 0)
        {
          pEdit->LineScroll(-nFirstVisible, 0);
        }
/**/
    }
/**/    
    return status;
}


int CSensorSimDlg::Log_InsertToFile(CString fileName, CString message) {
    int     status = STAT_OK;
    // WRITE INTO LOG FILE 
    CFile   file;
    if (file.Open(fileName, CFile::modeWrite | CFile::modeCreate | CFile::modeNoTruncate)) {
        file.SeekToEnd();
        file.Write(message, message.GetLength());    
        file.Close();
    }
    else status = STAT_FILE_OPEN_FAIL;
    
    return status;
}

void CSensorSimDlg::ClearPerformance() {
	pSensorSim->perfNestLevel = 0;	
	pSensorSim->perfTimeList.clear();
    pSensorSim->perfCallTime.clear();
    pSensorSim->perfCallCounter.clear();
}

void CSensorSimDlg::ShowPerformance() {
    lcs::iterator	iter;
    msd::iterator   iter2;
    msd::iterator   iter3;
    int             level = 0;
    CString         message;
    
    Log_InsertToFile("perfTime.txt", "\r\nFUNCTIONS STATISTICS\r\n");
    for (iter3 = pSensorSim->perfCallTime.begin(); iter3 != pSensorSim->perfCallTime.end(); iter3++) {
        double min = ULLONG_MAX;
        for (iter2 = pSensorSim->perfCallCounter.begin(); iter2 != pSensorSim->perfCallCounter.end(); iter2++) {
            if (iter2->second < min && iter2->second != -1) {
                min = iter2->second;
            }
        } 
        
        if (min != ULLONG_MAX) {
            for (iter2 = pSensorSim->perfCallCounter.begin(); iter2 != pSensorSim->perfCallCounter.end(); iter2++) {
                if (iter2->second == min && iter2->second != -1) {
	                message.Format("totalTime: %18.0Lf | total calls: %8.0Lf | time per call : %12.0Lf (%s)\r\n", pSensorSim->perfCallTime[(LPCTSTR)iter2->first], iter2->second, pSensorSim->perfCallTime[(LPCTSTR)iter2->first] / iter2->second, iter2->first);
	                Log_InsertToFile("perfTime.txt", message);

                    iter2->second = -1;
                    break;
	            }
	        }
	    }
    }
/*
    Log_InsertToFile("perfTime.txt", "\r\nTOTAL FUNCTION CALL\r\n");
    for (iter2 = pSensorSim->perfCallCounter.begin(); iter2 != pSensorSim->perfCallCounter.end(); iter2++) {
	    message.Format("%s : %.0Lf \r\n", iter2->first, iter2->second);
	    Log_InsertToFile("perfTime.txt", message);
    }
/**/    
/*    
    for (iter = pSensorSim->perfTimeList.begin(); iter != pSensorSim->perfTimeList.end(); iter++) {
	    level = atoi(*iter);
	    message = "";
	    for (int i = 0; i < level; i++) message += "  ";
	    message += *iter;
	    message += "\r\n";
	    Log_InsertToFile("perfTime.txt", message);
    }
/**/    
    
    LOG_INSERTSTRING("Performance saved.");
}





int CSensorSimDlg::GetBasicSettings(BASIC_INIT_DATA* pBasicSettings) {
    int status = STAT_OK;
    
    UpdateData(TRUE);
    
    pBasicSettings->clear();

    // GET SETTINGS FROM CBasicTab
    status = m_tabBasic.GetDlgData(pBasicSettings);

    // GET SETTINGS FROM m_tabKeyEstablish
    status = m_tabKeyEstablish.GetDlgData(pBasicSettings);

    // GET SETTINGS FROM m_tabKeyInfect
    status = m_tabKeyInfect.GetDlgData(pBasicSettings);

    // GET SETTINGS FROM m_tabKeyPredistrib
    status = m_tabKeyPredistrib.GetDlgData(pBasicSettings);

    // GET SETTINGS FROM m_tabBSRoute
    status = m_tabBSRoute.GetDlgData(pBasicSettings);
 
    // GET SETTINGS FROM m_tabNeighLeash
    status = m_tabNeighLeash.GetDlgData(pBasicSettings);

	// GET SETTINGS TO m_tabMesh
    status = m_tabMesh.GetDlgData(pBasicSettings);

    // HEADER
    status = GetBasicSettingsHeader(pBasicSettings);

	m_hostPC.Trim();
	if (m_hostPC.GetLength() > 0) {pBasicSettings->remoteConfig.actualRemoteHost = m_hostPC;}
	else {pBasicSettings->remoteConfig.actualRemoteHost = HOST_ACTUAL;}

    CSensorEnv::GAS_AllocateDefaultStrategyStructs(m_pGAStrategy);


    return status;
}

int CSensorSimDlg::SetBasicSettings(BASIC_INIT_DATA* pBasicSettings) {
    int status = STAT_OK;
    
    // SET SETTINGS TO CBasicTab
    status = m_tabBasic.SetDlgData(pBasicSettings);

    // SET SETTINGS TO m_tabKeyEstablish
    status = m_tabKeyEstablish.SetDlgData(pBasicSettings);

    // SET SETTINGS TO m_tabKeyInfect
    status = m_tabKeyInfect.SetDlgData(pBasicSettings);

    // SET SETTINGS TO m_tabKeyPredistrib
    status = m_tabKeyPredistrib.SetDlgData(pBasicSettings);

    // SET SETTINGS TO m_tabBSRoute
    status = m_tabBSRoute.SetDlgData(pBasicSettings);
 
    // SET SETTINGS TO m_tabNeighLeash
    status = m_tabNeighLeash.SetDlgData(pBasicSettings);

	// SET SETTINGS TO m_tabRemoteControl
    status = m_tabRemoteControl.SetDlgData(pBasicSettings);

	// SET SETTINGS TO m_tabMesh
    status = m_tabMesh.SetDlgData(pBasicSettings);

    m_hostPC = pBasicSettings->remoteConfig.actualRemoteHost;

    UpdateData(FALSE);
    return status;
}

int CSensorSimDlg::GetBasicSettingsHeader(BASIC_INIT_DATA* pBasicSettings) {
    // PROGRAM VERSION + DATE
    CVersionInfo    ver;    
    ver.GetVersionInfo("SensorSim.exe");
    pBasicSettings->simulSWVersion = ver.m_strFixedProductVersion;
    char timeStr[MAX_PATH];_strdate(timeStr); 
    pBasicSettings->simulDate = timeStr;
    _strtime(timeStr);
    pBasicSettings->simulDate += " ";
    pBasicSettings->simulDate += timeStr;
    
    return STAT_OK;
}


LRESULT CSensorSimDlg::OnLogInsertString(WPARAM wParam, LPARAM lParam) {
    // INSERT INTO LOG
    switch (lParam) { 
        case 1: {
            Log_InsertString((LPCTSTR) ((char*) wParam), TRUE);  
            break;
        }
        case 2: {
            Log_InsertString((LPCTSTR) ((char*) wParam), FALSE);  
            break;
        }
        case 3: {
            Log_AppendString((LPCTSTR) ((char*) wParam));  
            break;
        }
        case 4: {
            Log_InsertClearLine();  
            break;
        }
        case 5: {
            Log_InsertSeparator();  
            break;
        }
    }

    
    // CLEAR LOG STRING    
    if (wParam) delete[] (char*) wParam;

    return 0;
}

LRESULT CSensorSimDlg::OnUpdateRNGSeed(WPARAM wParam, LPARAM lParam) {
    // UPDATE RNG SEED FIELD
    m_tabBasic.UpdateData(TRUE);
    m_tabBasic.m_randomSeed.Format("%d", (DWORD) wParam);
    m_tabBasic.UpdateData(FALSE);
    return 0;
}

void CSensorSimDlg::OnClose() 
{
    BOOL    close = FALSE;

    if (m_pActualThread != NULL) {
        if (MessageBox("Running sub-thread with simulation detected. Do you really want to close application?", "Running simulations on background", MB_YESNO | MB_ICONWARNING) == IDYES) {
        	TerminateThread(pSensorSim->m_pActualThread->m_hThread, 0);
            close = TRUE;
        }
    }
    else {
        close = TRUE;
    }

    if (close) {
        pSensorSim->m_sensorEnv.Release();
        CDialog::OnClose();
    }
}

void CSensorSimDlg::OnEnChangeLogs()
{
    // TODO:  If this is a RICHEDIT control, the control will not
    // send this notification unless you override the CDialog::OnInitDialog()
    // function and call CRichEditCtrl().SetEventMask()
    // with the ENM_CHANGE flag ORed into the mask.

    // TODO:  Add your control notification handler code here
}




CString     lastSuccessApplicationChannel = "";

UINT Answer(void* a) {
    Socket* s = (Socket*) a;
    int         status = STAT_OK;
    CString     value;
    CString     command;
    CString     response;
    CString     message;
    int         pos = 0;
    int         pos2 = 0;

    while (1) {
        Sleep(100);
   
        // TERMINATE
        if (pSensorSim->m_bStopThread) return 0; 
   
        std::string r = s->ReceiveLine();
        value = r.c_str();
        
        if (value != "") { 
            message.Format("\n<< %s", value);
            LOG_INSERTSTRING(message);        

            pos = value.Find(PROXY_SEPARATOR);
            command = value.Left(pos);
            pos++;
            
            BOOL    bRecognizedCommand = FALSE;
            
            // GET RUNNING INSTANCES
            if (command.CompareNoCase(PROXY_GETINSTANCES) == 0) {
                bRecognizedCommand = TRUE;

				// OPEN FILE WITH INSTANCES LOGS
				int		retStatus = STAT_OK;
				lcs		instances;
				CString usedLog = S3_INSTANCES_LOGS_C;
				// TRY TO LOAD FROM FIRST ACCESSIBLE LOG FILE
				if (CCommonFnc::File_GetIniSections(S3_INSTANCES_LOGS_C, &instances) != STAT_OK) {
				    usedLog = S3_INSTANCES_LOGS_D;
				    if (CCommonFnc::File_GetIniSections(S3_INSTANCES_LOGS_D, &instances) != STAT_OK) {
                        usedLog = S3_INSTANCES_LOGS_E;
                        retStatus = CCommonFnc::File_GetIniSections(S3_INSTANCES_LOGS_E, &instances);
                    }
                }
				
				if (retStatus == STAT_OK) {
					response.Format("%s#OK#", PROXY_GETINSTANCES);        
					
					// PASS OVER ALL SECTIONS
					lcs::iterator	iter;
					CString			instanceString;
				    char			iniValue[MAX_INI_VALUE_CHAR];
					for (iter = instances.begin(); iter != instances.end(); iter++) {
						instanceString = *iter;
						instanceString += PROXY_VALUE_SEPARATOR;
/*
						// CHECK FOR INSTANCE LIVENESS
						CTime     lastReset = CTime::GetCurrentTime();
						CTime     actualTime = CTime::GetCurrentTime();
						CTimeSpan ts(0, 6, 0, 0 ); 
						CTimeSpan ts2(0, 0, 5, 0 ); 

						actualTime = CTime::GetCurrentTime();
						if ((actualTime - ts) > lastReset) {
						}
						S3_INSTANCES_TIME_DEAD
/**/						
						GetPrivateProfileString(*iter, "STATUS", "", iniValue, MAX_INI_VALUE_CHAR, usedLog);
						instanceString += iniValue;
						instanceString += PROXY_VALUE_SEPARATOR;
						GetPrivateProfileString(*iter, "DATE", "", iniValue, MAX_INI_VALUE_CHAR, usedLog);
						instanceString += iniValue;

						response += instanceString;        
						response += PROXY_SEPARATOR;
					}
				}
				else {
					response.Format("%s#FAIL#%d#", PROXY_GETINSTANCES, retStatus);        
				}

				response += SCSAT_SOCKET_ENDSEQ;
				std::string  cmd((LPCTSTR) response);
                s->SendLine(cmd);
                
                break;
            }

            // STOP
            if (command.CompareNoCase(PROXY_DISCONNECT) == 0) {
                bRecognizedCommand = TRUE;

                response.Format("%s#OK#", PROXY_DISCONNECT);        
                response += SCSAT_SOCKET_ENDSEQ;
                
                std::string  cmd((LPCTSTR) response);
                s->SendLine(cmd);
                
                break;
            }
            
            // GET FILE CONTENT
            if (command.CompareNoCase(PROXY_GETTEXTFILECONTENT) == 0) {
                bRecognizedCommand = TRUE;

                // GET PARAMS
                CString filePath;
                
                value += PROXY_SEPARATOR;
                if ((pos2 = value.Find(PROXY_SEPARATOR, pos)) != -1) {
                    filePath = value.Mid(pos, pos2 - pos);    
                    pos = pos2 + 1;
                }
                
                if (filePath != "") { 
                    // LOCATE RESULTS FILE
                    CString targetFile;
                    CString results;    
                    CFile   file;
                    targetFile.Format("%s\\%s", pSensorSim->m_basePath, filePath);
                    // READ CONTENT OF THE FILE
                    if (file.Open(targetFile, CFile::modeRead)) {
                        int len = file.GetLength() + 100;
                        char*   buffer = new char[len];
                        memset(buffer, 0, len);
                        file.Read(buffer, len);     
                        results = buffer;
                        delete[] buffer;

                        response.Format("%s#OK#%s#", PROXY_GETTEXTFILECONTENT, results); 
                    }
                    else {
                        response.Format("%s#FAIL#%d#FailToOpenTargetFile#", PROXY_GETTEXTFILECONTENT, status);        
                    }
                }
                else {
                    response.Format("%s#FAIL#%d#NotEnoughtParameters#", PROXY_GETTEXTFILECONTENT, status);        
                }
            }
            
			
            // RUN APPLICATION
            if (command.CompareNoCase(PROXY_RUNAPPLICATION) == 0) {
                bRecognizedCommand = TRUE;

                // GET PARAMS
                CString filePath;
				CString params;

                value += PROXY_SEPARATOR;
                if ((pos2 = value.Find(PROXY_SEPARATOR, pos)) != -1) {
                    filePath = value.Mid(pos, pos2 - pos);    
                    pos = pos2 + 1;
                }
                value += PROXY_SEPARATOR;
                if ((pos2 = value.Find(PROXY_SEPARATOR, pos)) != -1) {
                    params = value.Mid(pos, pos2 - pos);    
                    pos = pos2 + 1;
                }
                
                if (filePath != "") { 
                    // LOCATE RESULTS FILE
                    CString cmdLine;
                    cmdLine.Format("\"%s\\%s\" %s", pSensorSim->m_basePath, filePath, params);
                
					WinExec(cmdLine, 0);

                    response.Format("%s#OK#", PROXY_RUNAPPLICATION); 
                }
                else {
                    response.Format("%s#FAIL#%d#NotEnoughtParameters#", PROXY_RUNAPPLICATION, status);        
                }
            }

            // COPY FILE
            if (command.CompareNoCase(PROXY_COPYFILE) == 0) {
                bRecognizedCommand = TRUE;

                // GET PARAMS
                CString origFilePath;
				CString targetFilePath;
                CString p1;
				CString p2;

                value += PROXY_SEPARATOR;
                if ((pos2 = value.Find(PROXY_SEPARATOR, pos)) != -1) {
                    p1 = value.Mid(pos, pos2 - pos);    
                    pos = pos2 + 1;
                }
                value += PROXY_SEPARATOR;
                if ((pos2 = value.Find(PROXY_SEPARATOR, pos)) != -1) {
                    p2 = value.Mid(pos, pos2 - pos);    
                    pos = pos2 + 1;
                }
                
                if (p1 != "" && p2 != "") { 
					origFilePath.Format("%s\\%s", pSensorSim->m_basePath, p1);
					targetFilePath.Format("%s\\%s", pSensorSim->m_basePath, p2);

                    // CREATE DIRECTORY
                    CString dirPath;
                    CCommonFnc::Path_ExtractDirPath(targetFilePath, &dirPath);
                    CCommonFnc::Dir_Create(dirPath);

					CopyFile(origFilePath, targetFilePath, FALSE);

                    response.Format("%s#OK#", PROXY_COPYFILE); 
                }
                else {
                    response.Format("%s#FAIL#%d#NotEnoughtParameters#", PROXY_COPYFILE, status);        
                }
            }


			// SET FILE CONTENT
            if (command.CompareNoCase(PROXY_SETFILECONTENT) == 0) {
                bRecognizedCommand = TRUE;

                // GET PARAMS
                CString filePath;
                int dataLength;
                
                value += PROXY_SEPARATOR;
                if ((pos2 = value.Find(PROXY_SEPARATOR, pos)) != -1) {
                    filePath = value.Mid(pos, pos2 - pos);    
                    pos = pos2 + 1;
                }
                value += PROXY_SEPARATOR;
                if ((pos2 = value.Find(PROXY_SEPARATOR, pos)) != -1) {
                    dataLength = atoi(value.Mid(pos, pos2 - pos));    
                    pos = pos2 + 1;
                }
                
                if (filePath != "" && dataLength > 0) { 
                    // LOCATE RESULTS FILE
                    CString targetFile;
                    CString results;    
                    CFile   file;
                    targetFile.Format("%s\\%s", pSensorSim->m_basePath, filePath);

                    // CREATE DIRECTORY
                    CString dirPath;
                    CCommonFnc::Path_ExtractDirPath(targetFile, &dirPath);
                    CCommonFnc::Dir_Create(dirPath);
                    
                    // WRITE CONTENT OF THE FILE
                    if (s->ReceiveBytesToFile((LPCTSTR) targetFile, dataLength + 1, SCSAT_SOCKET_TIMEOUT) == 0) {
                        response.Format("%s#OK#%s#", PROXY_SETFILECONTENT, results); 

                    }
                    else {
                        response.Format("%s#FAIL#%d#FailToReceiveToTargetFile#", PROXY_SETFILECONTENT, status);        
                    }
                
                    response.Format("%s#OK#%s#", PROXY_SETFILECONTENT, results); 
                }
                else {
                    response.Format("%s#FAIL#%d#NotEnoughtParameters#", PROXY_SETFILECONTENT, status);        
                }
            }
            
            if (!bRecognizedCommand) {
                response.Format("##FAIL#UnrecognizedCommand#");        
            }
            
            response += SCSAT_SOCKET_ENDSEQ;
            std::string  cmd(response);
            s->SendLine(cmd);
            
            message.Format(">> %s\n", response);
            LOG_INSERTSTRING(message);        
        }
    }

    // DECREASE NUMBER OF ACTIVE CONNECTIONS
    pSensorSim->m_numSocketConnections -= 1;

    delete s;


    return 0;
}

UINT StartProxy(void* a) {
    SocketServer* pSocketServer = (SocketServer*) a; 

    LOG_INSERTSTRING("Proxy started");        

    while (1) {
        try {
            Socket* s=pSocketServer->Accept();

            LOG_INSERTSTRING("\nNew connection detected and waiting for service");        

            // TERMINATE IF REQUIRED
            if (pSensorSim->m_bStopThread) break;

            while (pSensorSim->m_numSocketConnections > 0) {
                // WAIT UNTIL PREVIOUS CONNECTION FINISH
            }

            // INCREASE NUMBER OF SERVED ACTIVE CONNECTIONS
            pSensorSim->m_numSocketConnections++;
            AfxBeginThread(Answer, (void*) s, THREAD_PRIORITY_NORMAL); 
        }
        catch(...) {
            // TERMINATE IF REQUIRED (POSSIBLE REASON FOR EXCEPTION)
            if (pSensorSim->m_bStopThread) break;
            else LOG_INSERTSTRING("Exception in pSocketServer->Accept");        
        }
    }

    return 0; 
}


void CSensorSimDlg::RunProxy(int port) {
    m_pSocketServer = new SocketServer(port, 1);   

    CString message;
    message.Format("Starting proxy on port %d", port);
    LOG_INSERTSTRING(message);        

    m_pProxyThread = AfxBeginThread(StartProxy, (void*) m_pSocketServer, THREAD_PRIORITY_NORMAL); 
}


int CSensorSimDlg::SocketSendLine(SocketClient* pSocket, CString line, CString* pResponse, CString* pStatus) {
	int		status = STAT_OK;
	int		pos = 0;
	int		pos2 = 0;

	pSocket->SendLine((LPCTSTR) line);

    string l = pSocket->ReceiveResponse(SCSAT_SOCKET_ENDSEQ, SCSAT_SOCKET_TIMEOUT);
	*pResponse = l.c_str();
	
	// SEARCH FOR RESULT OF QUERY (command#status#...)
	if ((pos = pResponse->Find("#")) != -1) {
		if ((pos2 = pResponse->Find("#", pos + 1)) != -1) {
			// SAVE status
			if (pStatus != NULL) *pStatus = pResponse->Mid(pos + 1, pos2 - pos - 1);
			
			// REMOVE command#status
			CString temp = pResponse->Mid(pos2); 

			// REMOVE ENDING @@ - SCSAT_SOCKET_ENDSEQ
			*pResponse = temp.Left(temp.Find(SCSAT_SOCKET_ENDSEQ)); 
		}
		else status = STAT_DATA_INCORRECT_LENGTH;
	}
	else status = STAT_DATA_INCORRECT_LENGTH;

	return status;
}

int CSensorSimDlg::RunRemoteExecution(CString host, CString configFilePath, CString instanceSubdir) {
	//
	// RUN ON SELECTED REMOTE COMPUTER
	//
	int                 status = STAT_OK;
	SocketClient*		pSocket = NULL;
	REMOTE_HOST_INFO	remoteInfo;
	CString				response;
	CString				request; 

	CString IP = host.Left(host.Find(":"));
    CString port = host.Right(host.GetLength() - host.Find(":") - 1);

	// try to connect to proxy on remote computer
	try {
		if ((pSocket = new SocketClient((LPCTSTR) IP, atoi(port))) != NULL) {
			CString				retStat;
			
			// COPY SCRIPT WITH SETTINGS
			CFile	file;
			CString	settings;
			if (file.Open(configFilePath, CFile::modeRead)) {
			    int	len = file.GetLength() * 3;
			    TCHAR*	buffer = new TCHAR[len];
			    memset(buffer, 0, len * sizeof(TCHAR));
			    file.Read(buffer, file.GetLength());
			    settings = buffer;
			    delete[] buffer;
			    file.Close();
            }
            else status = STAT_FILE_OPEN_FAIL;
            
            if (status == STAT_OK) {
			    CString command;

			    command.Format("%s#SensorSim.exe#%s\\SensorSim.exe#", PROXY_COPYFILE, instanceSubdir);
			    pSocket->SendLine((LPCTSTR) command);
			    string l = pSocket->ReceiveResponse(SCSAT_SOCKET_ENDSEQ, SCSAT_SOCKET_TIMEOUT);
			    CString data = l.c_str();

			    command.Format("%s#%s\\run_cfg.ini#%d#\n%s", PROXY_SETFILECONTENT, instanceSubdir, settings.GetLength(), settings);
			    pSocket->SendLine((LPCTSTR) command);
			    l = pSocket->ReceiveResponse(SCSAT_SOCKET_ENDSEQ, SCSAT_SOCKET_TIMEOUT);
			    data = l.c_str();

			    command.Format("%s#%s\\SensorSim.exe#/s:\"run_cfg.ini\" /r #", PROXY_RUNAPPLICATION, instanceSubdir);
			    pSocket->SendLine((LPCTSTR) command);
			    l = pSocket->ReceiveResponse(SCSAT_SOCKET_ENDSEQ, SCSAT_SOCKET_TIMEOUT);
			    data = l.c_str();
		    }
		}
		else {
		}

		// disconnect
		request.Format("%s%s", PROXY_DISCONNECT, PROXY_SEPARATOR);
		pSensorSim->SocketSendLine(pSocket, request, &response);
		delete pSocket;
	}
	catch (...) {
		status = STAT_CHANNEL_NOT_EXISTS;	
	}
	
	return status;
}


void CSensorSimDlg::OnBnClickedStopCurrentOperations()
{
    // SET SOFT FLAG FOR STOPPING CURRENT FLAG
    pSensorSim->m_stopThreadSoft = TRUE;
}
